! Node -- Nils' Own Database, Version 3.4
! Copyright (C) 1997,1998,1999,2000,2001,2002,2003 Nils M Holm.
! All rights reserved.
! See the file LICENSE for conditions of use.
!
! 2003-02-07	Using the actual screen size now.
! 2003-02-07	Made the license text viewable on small screens.
! 2003-01-17	New title screen.
! 2003-01-17	Changed default help text colors.
! 2002-09-28	Fixed some typos.
! 2002-09-28	'O' was used to sEt options, should have been 'E'.
! 2001-12-08	Fixed 'change view' option on small screens
! 2001-12-07	Fixed crash when entering new data in scrolled window
! 2001-12-07	Fixed auto-conversion of 16th field
! 2001-12-07	Fixed 'holes' in menu bar in zoom mode
! 2001-12-07	Added export summary window
! 2001-12-05	Fixed quoted quotes in import/export
! 2001-12-05	Added Options and License to main menu
! 2000-10-28	Internal Beta Release (Hanne)
! 2000-10-26	Implemented tagtbl/index transfer to Node RG
! 2000-10-24	There is one source program for all systems now
! 2000-10-24	Started development of the Node Report Generator
! 2000-10-24	Implemented DOS mode + auto-detection
! 2000-10-24	Added configurable views (see Database menu)
! 2000-10-23	Rewrote config management (using T3Xtools/CONFIG)
! 2000-10-23	Removed the internal report writer
! 2000-10-23	Made dbopen() auto-convert 2.x databases to 3.x.
! 2000-10-23	Implemented loadable color sets
! 2000-10-23	Implemented detection of index type (2/4 BPW)
! 2000-10-23	Added file select boxes + removed Hotlists
! 2000-10-23	Added auto-regeneration of unusable indices
! 2000-10-22	'Ported' the whole thing to T3X 6.8
! 2000-04-07	Version 2, Release 6
! 2000-04-07	Fixed clearing of help screen in zoom mode
! 2000-03-31	Fixed quicklocate() (didn't work since 2000-03-18)
! 2000-03-26	Version 2, Release #6 Beta2
! 2000-03-26	Fixed wrong menu clear color in template hotlist
! 2000-03-22	Made help screens more readable + updated keys
! 2000-03-21	A FF will be sent after writing a report now
! 2000-03-20	Implemented cut+paste fns in edit boxes ([^Y])
! 2000-03-19	Version 2, Release #6 Beta
! 2000-03-19	Fixed some message locations (cosmetical)
! 2000-03-19	Added %field:length syntax to report writer
! 2000-03-18	Added kill-to-eol [^K] binding in edit boxes
! 2000-03-18	Added hotlist for templates (HOTLIST.tps)
! 2000-03-18	Added code to intercept key collisions in input
! 2000-03-17	Wrote CSL import routine
! 2000-03-17	Selections will be adjusted after key changes now
! 2000-03-17	Added option to include headers in exported CSL's
! 2000-01-31	Version 2, Release #5
! 2000-01-31	Added license screen
! 1999-12-23	Version 2, Release #4 beta
! 1999-12-23	Fixed misc. typos and obsolete hintbar texts
! 1999-12-23	Fixed a bug in comparison of short (<KEYLEN) records
! 1999-12-22	Added warning message before merging databases
! 1999-12-21	Tags will no longer be removed when adding records
! 1999-12-21	Added CSL merge/export routines
! 1999-11-17	Version 2, Release #3
! 1999-11-17	Added help screen for edit boxes
! 1999-11-16	Created node.gen, which must be processed with SED.
! 1999-10-20	Version 2, Release #2
! 1999-08-05	Wrote scrollable edit boxes for 1000CX version.
! 1999-08-05	Version 2, Release #1
! 1999-08-05	Added configurable options.
! 1999-07-27	Release #7
! 1999-07-26	Created HP1000CX version.
! 1999-07-25	Removed all but english messages.
! 1998-04-12	Implemented hot list selections
! 1998-02-04	Fixed PGDN/END adjustment in 15-record dbs.
! 1998-01-18	Bug fix (sic!): Accept Umlaute in edit fields
! 1998-01-17	Release #6
! 1998-01-17	Intercepted insertion of empty key field
! 1998-01-17	Implemented partial matches in selections
! 1998-01-17	Beta Release #5
! 1998-01-16	Stick to current record when (un)limiting views
! 1998-01-16	Implemented Limited Views
! 1998-01-15	Made current record visible in DELETE prompts
! 1998-01-15	Index and Select operations changed to memcomp()
! 1998-01-11	Beta Release #4
! 1998-01-11	Added insert/delete line commands in EDIT()
! 1998-01-05	Fixed some typos in the german version
! 1998-01-05	Fixed empty database bug
! 1997-12-14	Beta release #3
! 1997-12-11	Multi-language suppport added; german version
! 1997-12-07	Beta release #2 (cancelled)
! 1997-12-01	First beta release
! 1997-11-24	Pre-release finished
! 1997-11-21	Initial idea, started implementation

module node(t3x, string, ttyctl, system, config, filebox, util);

object t[t3x], str[string], tty[ttyctl], sys[system], fbx[filebox], u[util];

const	RECORDMAX	= 1024;

const	RECORDSIZE	= 1024;
const	RECORDCELLS	= 512;	! RECORDSIZE / 2
const	FIELDMAX	= 16;
const	TAGTBLSIZE	= RECORDMAX+1;
const	NAMELEN		= 30;
const	FNAMELEN	= 30;	! change to 8 on DOS
const	PATHLEN		= 256;
const	NCOPIES		= 8;

const	MAXCOLS		= 256,
	NCXLINES	= 18,
	NCXCOLS		= 64;

const	NDXLEN = 16, I_key = 0, I_rec = 15;
const	KEYLEN = 29;

const	EOPEN = %1, EMAGIC = %2, EIHDR = %3, EINDEX = %4, ECREAT = %5;
const	ERRMAX = ECREAT;

object	Cnf[config];
var	Database[PATHLEN+1], Auxname[PATHLEN+1];
var	Descriptor[RECORDCELLS+1];
var	Record[RECORDCELLS+1];
var	Normrec[RECORDCELLS+1];		! Used to locate records
var	Auxrec[RECORDCELLS*2+2];	! Used for rendering reports, etc
var	Copybuf::RECORDSIZE, Copies[NCOPIES], Lastcopy;
var	Index[NDXLEN*RECORDMAX];
var	Taglist[FIELDMAX+1], Vlist[FIELDMAX];
var	Tagtbl::TAGTBLSIZE;
var	Title;
var	Nfields, Vfields;
var	Nrecords;
var	Ntagged;
var	Rawcount;
var	Dbfd;
var	Blanks::MAXCOLS+2, Hline::MAXCOLS+2;
var	DoExit;
var	Limited, SavedLimited;
var	Xmax, Ymax;
var	Lasthint;
var	Confpath::PATHLEN+1;
var	Nxbits;
var	O_hints,
	O_warnings,
	O_zoom,
	O_dosflag,
	O_rg_flags,
	O_rg_addcr;
var	O_borderc::NAMELEN+1;
var	O_rgpath::PATHLEN+1,
	O_rg_print::PATHLEN+1,
	O_rg_view::PATHLEN+1;
var	C_background,
	C_alert,
	C_menuframe,
	C_menutext,
	C_menubar,
	C_menuhigh,
	C_infoframe,
	C_infotext,
	C_promptframe,
	C_prompttext,
	C_promptbar,
	C_editframe,
	C_editprompt,
	C_edittext,
	C_editbar,
	C_browseframe,
	C_browsetext,
	C_browsehead,
	C_browsebar,
	C_browsetag,
	C_logo	,
	C_titlehi,
	C_titlelo,
	C_helpframe,
	C_helptext,
	C_helpkey,
	C_tagind,
	C_marker,
	C_limitind;

strcat(a, b) do var k;
	k := str.length(a);
	str.copy(@a::k, b);
	return str.length(a);
end

var pntoabuf::33;
pntoa(n, w, filler) do var s, i, k;
	t.memfill(pntoabuf, filler, 32);
	str.numtostr(@pntoabuf::20, n, 10);
	k := str.length(@pntoabuf::20);
	if (w <= k) return @pntoabuf::20;
	return @pntoabuf::(20-w+k);
end

getkey() return tty.readc();

box(x, y, dx, dy) do var i, c;
	c := Blanks::(dx-x);
	Blanks::(dx-x) := 0;
	for (y=y, dy) do
		tty.move(x, y);
		tty.writes(Blanks);
	end
	Blanks::(dx-x) := c;
end

fbox(x, y, dx, dy) do var i, c, c2;
	c := Blanks::(dx-x-2);
	Blanks::(dx-x-2) := 0;
	c2 := Hline::(dx-x-2);
	Hline::(dx-x-2) := 0;
	tty.move(x, y);
	tty.writec(O_borderc::0); tty.writes(Hline);
	tty.writec(O_borderc::1);
	for (y=y+1, dy-1) do
		tty.move(x, y);
		tty.writec(O_borderc::5);
		tty.writes(Blanks);
		tty.writec(O_borderc::5);
	end
	tty.move(x, y);
	tty.writec(O_borderc::2);
	tty.writes(Hline);
	tty.writec(O_borderc::3);
	Blanks::(dx-x-2) := c;
	Hline::(dx-x-2) := c2;
end

hintbar(y, hint) do var k, x;
	if (\O_hints) return 0;
	tty.color(C_background);
	tty.move(0, y); tty.clreol();
	if (hint) do
		Lasthint := hint;
		k := str.length(hint);
		x := (Xmax/2-2)-(k>>1);
		tty.move(x, y);
		tty.color(C_infotext);
		tty.writec('\s');
		tty.writes(hint);
		tty.writec('\s');
	end
end

menu(x, y, d, items, keys, hints, clear) do
	var	maxx, maxy;
	var	nitem, offset, oo;
	var	i, j, k;
	var	redraw;

	maxx := 0;
	maxy := 0;
	while (items[maxy] \= %1) do
		j := str.length(items[maxy]);
		if (j > maxx) maxx := j;
		maxy := maxy+1;
	end
	nitem := maxy;
	if (maxy > Ymax-9) do
		if (maxx < 8) maxx := 6;
		maxy := Ymax-9;
	end
	if (x < 0) x := (Xmax/2-1)-(maxx+4>>1);
	if (y < 0) y := (Ymax/2)-(maxy+2>>1);
	redraw := 1;
	offset := 0;
	i := d;
	while (1) do
		if (redraw) do
			tty.color(C_menuframe);
			fbox(x, y, x+maxx+4, y+maxy+2);
			tty.color(C_menutext);
			for (j=offset, nitem) do
				if (j-offset >= maxy) leave;
				tty.move(x+2, y+j-offset+1);
				tty.writes(items[j]);
			end
			if (offset) do
				tty.move(x+2, y);
				tty.color(C_menuhigh);
				tty.writes("--more--");
			end
			if (nitem-offset > maxy) do
				tty.move(x+2, y+maxy+1);
				tty.color(C_menuhigh);
				tty.writes("--more--");
			end
			redraw := 0;
		end
		oo := offset;
		tty.move(x+2, y+i-offset+1);
		tty.color(C_menubar);
		tty.writes(items[i]);
		tty.color(ttyctl.F_GREY|ttyctl.B_GREY);
		if (hints) hintbar(Ymax-2, hints[i]);
		tty.move(x, y);
		k := getkey();
		if ('A' <= k /\ k <= 'Z') k := k-'A'+'a';
		tty.color(C_menutext);
		tty.move(x+2, y+i-offset+1);
		tty.writes(items[i]);
		ie (k = ttyctl.K_ESC \/ k = ttyctl.K_LEFT \/ k = ':') do
			i := %1; leave;
		end
		else ie (k = ttyctl.K_CR \/ k = ttyctl.K_RIGHT) leave;
		else ie (k = ttyctl.K_UP \/ k = 'P'-'@') do
			i := i-1;
			ie (i<0) do
				i := nitem-1;
				if (nitem > maxy)
					offset := nitem/maxy*maxy;
			end
			else if (i < offset) do
				offset := offset - maxy;
			end
		end
		else ie (k = ttyctl.K_DOWN \/ k = 'N'-'@') do
			i := i+1;
			ie (i>=nitem) do
				i := 0; offset := 0;
			end
			else if (i-offset >= maxy) do
				offset := offset + maxy;
			end
		end
		else do
			for (j=0, maxy) do
				if (\keys[j]) leave;
				if (keys[j] = k) do
					i := j; leave;
				end
			end
			if (keys[j] = k) leave;
		end
		if (offset \= oo) redraw := 1;
	end
	tty.color(clear);
	box(x, y, x+maxx+4, y+maxy+2);
	return i;
end

info(x, y, m, cset) do
	var	maxx, maxy;
	var	k, i;

	maxx := 0;
	maxy := 0;
	while (m[maxy] \= %1) do
		k := str.length(m[maxy]);
		if (k > maxx) maxx := k;
		maxy := maxy+1;
	end
	if (x < 0) x := (Xmax/2-1)-(maxx+6>>1);
	if (y < 0) y := (Ymax/2-1)-maxy/2;
	tty.color(cset[0]);
	fbox(x, y, x+maxx+6, y+maxy+2);
	tty.color(cset[1]);
	for (i=0, maxy) do
		tty.move(x+3, y+i+1);
		tty.writes(m[i]);
	end
end

wh(x, y, m) do var i, j, k, so;
	tty.move(x, y);
	tty.color(C_helptext);
	so := 0;
	k := str.length(m);
	for (i=0, k) do
		j := i;
		while (m::i /\ m::i \= '~') i := i+1;
		if (\m::i) leave;
		m::i := 0;
		tty.writes(@m::j);
		m::i := '~';
		ie (so) do
			tty.color(C_helptext);
			so := 0;
		end
		else do
			tty.color(C_helpkey);
			so := 1;
		end
	end
	tty.writes(@m::j);
end

help(x, y, m) do
	var	maxx, maxy;
	var	k, i, j;

	maxx := 0;
	maxy := 0;
	while (m[maxy] \= %1) do
		k := str.length(m[maxy]);
		j := 0;
		for (i=0, k) if (m[maxy]::i = '~') j := j+1;
		k := k-j;
		if (k > maxx) maxx := k;
		maxy := maxy+1;
	end
	if (x < 0) x := (Xmax/2-1)-(maxx+6>>1);
	if (y < 0) y := (Ymax/2-1)-maxy/2;
	tty.color(C_helpframe);
	fbox(x, y, x+maxx+6, y+maxy+2);
	tty.color(C_helptext);
	for (i=0, maxy) wh(x+3, y+i+1, m[i]);
end

clrhelp() do var i;
	if (Xmax >= 80) return 0;
	tty.color(C_background);
	for (i=0, Ymax-2) do
		tty.move(0, i);
		tty.clreol();
	end
end

prompt(x, y, d, m, yes, no) do var k, j, c;
	k := str.length(m);
	j := str.length(no);
	if (x < 0) x := (Xmax/2-1)-(k+6>>1);
	if (y < 0) y := (Ymax/2-3);
	tty.color(C_promptframe);
	fbox(x, y, x+k+6, y+5);
	tty.move(x+3, y+1);
	tty.color(C_prompttext);
	tty.writes(m);
	while (1) do
		tty.color(d-> C_prompttext: C_promptbar);
		tty.move(x+3, y+3);
		tty.writes(yes);
		tty.move(x+k+3-j, y+3);
		tty.color(d-> C_promptbar: C_prompttext);
		tty.writes(no);
		tty.move(x, y); tty.color(C_promptframe);
		c := getkey();
		if ('a' <= c /\ c <= 'z') c := c-'a'+'A';
		ie (c = ttyctl.K_RIGHT \/ c = ttyctl.K_LEFT \/ c = '\t')
			d := \d;
		else ie (c = ttyctl.K_ESC \/ k = ':') do d := %1; leave; end
		else ie (c = ttyctl.K_CR) do d := d-> 0: 1; leave; end
		else ie (c = yes::0) do d := 1; leave; end
		else if (c = no::0) do d := 0; leave; end
	end
	tty.color(C_prompttext);
	tty.move(x+3, y+3); tty.writes(yes);
	tty.move(x+k+3-j, y+3); tty.writes(no);
	return d;
end

copy(s, k) do var last, i, n;
	k := k&255;
	if (\k) return 0;
	n := 0;
	if (Lastcopy >= NCOPIES) Lastcopy := Lastcopy-1;
	if (Lastcopy) do
		last := @Copybuf::Copies[Lastcopy-1];
		n := last::0 + 2;
	end
	while (Lastcopy /\ k + Copies[Lastcopy-1] + n >= RECORDSIZE)
		Lastcopy := Lastcopy-1;
	if (Lastcopy) do
		t.memcopy(@Copybuf::(k+2), Copybuf, Copies[Lastcopy-1]+n);
		for (i=Lastcopy, 0, %1)
			Copies[i] := Copies[i-1] + k+2;
	end
	t.memcopy(@Copybuf::1, s, k);
	Copybuf::0 := k;
	Copybuf::(k+1) := 0;
	Copies[0] := 0;
	Lastcopy := Lastcopy+1;
end

yank(s) do
	var	items[NCOPIES+1], hints[NCOPIES];
	var	saved[NCOPIES];
	var	k, i, max;

	if (\Lastcopy) do
		info(%1, %1, [ "Yank list is empty -- press [ESC]",
		%1 ], [ (C_infoframe), (C_infotext) ]);
		getkey();
		return -1;
	end
	max := 0;
	for (i=0, Lastcopy) do
		items[i] := @Copybuf::(Copies[i]+1);
		hints[i] := 
		"Select text to yank back, [ENTER] = copy, [ESC] = cancel";
		k := str.length(items[i]);
		ie (k > 32) do
			saved[i] := items[i]::32;
			items[i]::32 := 0;
			max := 32;
		end
		else do
			if (k > max) max := k;
			saved[i] := 0;
		end
	end
	items[i] := %1;
	k := menu(Xmax-max-4, 0, 0, items, [0], hints, C_background);
	for (i=0, Lastcopy) do
		if (saved[i]) items[i]::32 := saved[i];
	end
	if (k < 0) return -1;
	i := Copybuf::Copies[k];
	t.memcopy(s, @Copybuf::(Copies[k]+1), i+1);
	return i;
end

editline(x, y, buffer, wlen, size, mp, allowlc) do
	var	i, k, j;
	var	redraw, off, cp, len;
	var	exit;
	var	modified;

	tty.move(x, y);
	tty.color(C_editbar);
	for (i=0, wlen) tty.writec('\s');
	redraw := 1;
	cp := 0;
	off := 0;
	len := str.length(buffer);
	exit := 0;
	modified := 0;
	while (1) do
		if (redraw) do
			tty.move(x, y);
			for (i=off, len) do
				if (i-off >= wlen) leave;
				tty.writec(buffer::i);
			end
			while (i-off < wlen) do
				tty.writec('\s');
				i := i+1;
			end
			redraw := 0;
		end
		if (exit) leave;
		tty.move(x+cp-off, y);
		k := getkey();
		ie ((k = ttyctl.K_RIGHT \/ k = 'F'-'@') /\ cp < len) do
			cp := cp+1;
			if (cp-off >= wlen) do
				off := off+1; redraw := 1; end
		end
		else ie ((k = ttyctl.K_LEFT \/ k = 'B'-'@') /\ cp) do
			cp := cp-1;
			if (cp<off) do
				off := off-1; redraw := 1; end
		end
		else ie (k = ttyctl.K_HOME \/ k = 'A'-'@') do
			redraw := off;
			cp := 0;
			off := 0;
		end
		else ie (k = ttyctl.K_END \/ k = 'E'-'@') do
			cp := len;
			off := len-wlen+1;
			if (off < 0) off := 0;
			redraw := 1;
		end
		else ie (cp /\ k = ttyctl.K_BKSP) do
			cp := cp-1;
			for (i=cp, len) buffer::i := buffer::(i+1);
			len := len-1;
			if (cp < off) do
				off := off - 5;
				if (off < 0) off := 0;
			end
			redraw := 1;
			modified := 1;
		end
		else ie (cp < len /\ (k = ttyctl.K_DEL \/ k = 127)) do
			for (i=cp, len) buffer::i := buffer::(i+1);
			len := len-1;
			redraw := 1;
			modified := 1;
		end
		else ie (k = 'U'-'@') do
			copy(buffer, len);
			buffer::0 := 0;
			cp := 0;
			off := 0;
			len := 0;
			redraw := 1;
			modified := 1;
		end
		else ie (k = 'K'-'@') do
			copy(@buffer::cp, len-cp);
			buffer::cp := 0;
			len := cp;
			redraw := 1;
			modified := 1;
		end
		else ie (k = 'Y'-'@') do
			j := yank(buffer);
			if (j >= 0) do
				len := j;
				cp := 0;
				off := 0;
				redraw := 1;
				modified := 1;
			end
			exit := 1;
		end
		else ie (k = ttyctl.K_CR \/ k = ttyctl.K_ESC \/
			k = ttyctl.K_UP \/ k = ttyctl.K_DOWN \/
			k = 'N'-'@' \/ k = 'P'-'@' \/
			k = ttyctl.K_PGUP \/ k = ttyctl.K_PGDN \/
			k = 'V'-'@' \/ k = 'R'-'@' \/
			k = 'X'-'@' \/
			(k = ttyctl.K_F1 /\ \allowlc) \/
			((k = 'O'-'@' \/ k = '\\'-'@' \/ k = 'D'-'@')
			/\ allowlc)
		) do
			tty.color(C_edittext);
			cp := 0;
			off := 0;
			redraw := 1;
			exit := 1;
		end
		else do
			if (len >= size \/ k < '\s' \/ k > 255) do
				loop;
			end
			for (i=len, cp-1, %1) buffer::(i+1) := buffer::i;
			buffer::cp := k;
			len := len+1;
			cp := cp+1;
			if (cp-off >= wlen) off := off+1;
			redraw := 1;
			modified := 1;
		end
	end
	mp[0] := modified;
	return k;
end

extract(text, off, max, buffer) do var i;
	i := 0;
	while (text::(off+i) /\ text::(off+i) \= '\n') do
		if (i >= max) leave;
		buffer::i := text::(off+i);
		i := i+1;
	end
	buffer::i := 0;
	return i;
end

insert(text, off, len, buffer, s0) do
	var	s1, delta;
	var	i;

	s1 := str.length(buffer);
	ie (s0 \= s1) do
		delta := s1-s0;
		ie (delta > 0) do
			for (i=len+delta, off-1, %1)
				text::i := text::(i-delta);
		end
		else do
			for (i=off, len+delta)
				text::i := text::(i-delta);
		end
	end
	else do
		delta := 0;
	end
	for (i=0, s1) text::(off+i) := buffer::i;
	return delta;
end

gotopos(rc, pos) do var i, lc;
	lc := 0;
	for (i=0, RECORDSIZE) do
		if (lc >= pos) leave;
		if (rc::i = '\n') lc := lc+1;
	end
	return i;
end

insfield(rc, pos, field) do var k, i, c;
	i := gotopos(rc, pos);
	k := str.length(field);
	c := rc::(RECORDSIZE-2);
	t.memcopy(@rc::(i+k+1), @rc::i, RECORDSIZE-i-k-1);
	t.memcopy(@rc::i, field, k);
	rc::(i+k) := '\n';
	rc::(RECORDSIZE-2) := c;
	rc::(RECORDSIZE-1) := '\n';
end

delfield(rc, pos) do var k, i;
	i := gotopos(rc, pos);
	k := i;
	while (rc::k \= '\n') k := k+1;
	k := k-i;
	t.memcopy(@rc::i, @rc::(i+k+1), RECORDSIZE-i-k-2);
end

edithelp() do var lh;
	help(%1, %1, [
	"Editor keys -- ~[^X]~ denotes ~[control]~ + ~[X]",
	"\s",
	"~[^F][^B]~   move cursor left/right    (or ~[arrows]~)",
	"~[^A][^E]~   move to beg./end of line",
	"~[^N][^P]~   move to next/prev. field  (or ~[arrows]~)",
	"~[^V][^R]~   move to next/prev. record (or ~[PgUp/Dn]~)",
	"~[DEL][<--]~ delete character / char left",
	"~[^U][^K]~   delete current field (to end of line)",
	"~[^X]~       undo (restore original content)",
	"~[^Y]~       paste deleted text from clipboard",
	"~[ESC]~      end editor",
	%1]);
	lh := Lasthint;
	hintbar(Ymax-2, "Press [ESC] to return");
	Lasthint := lh;
	getkey();
	clrhelp();
end

decl	dbinfo(2);
edit(recno, x, y, sx, tags, text, ekeys, allowlc, ro) do
	var	sy, xx;
	var	i, j, k, nf, nv, first, maxx, pos;
	var	ex, ek;
	var	off[FIELDMAX+1];
	var	len;
	var	buffer[RECORDSIZE];
	var	s0, delta;
	var	mf;
	var	redraw;
	var	scroll;

	nf := 0;
	while (tags[nf] \= %1) nf := nf+1;
	maxx := 0;
	scroll := nf > 10 /\ Ymax < 25;
	nv := scroll-> 10: nf;
	first := 0;
	for (i=0, nf) do
		j := str.length(tags[i]);
		if (j > maxx) maxx := j;
	end
	if (sx < 0) do sx := Xmax; x := %1; end
	sy := nv+2;
	if (x < 0) x := (Xmax/2-1) - (sx>>1);
	if (x < 0) x := 0;
	if (y < 0) y := (Ymax/2) - (sy>>1);
	if (y < 0) y := 0;
	ex := x+6+maxx;
	ek := sx-maxx-9;
	xx := 0;
	pos := 0;
	redraw := 1;
	while (1) do
		if (redraw) do
			tty.color(C_editframe);
			fbox(x, y, x+sx, y+sy);
			tty.color(C_editprompt);
			for (i=0, nv) do
				tty.move(x+3, y+i+1);
				tty.writes(tags[i+first]);
				tty.move(x+3+maxx, y+1+i);
				tty.writes(" : ");
			end
			tty.move(ex, y+1);
			tty.color(C_edittext);
			off[0] := 0;
			j := 1;
			len := 0;
			while (text::len /\ j<=nf) do
				ie (text::len = '\n') do
					off[j] := len+1;
					j := j+1;
					if (j >= first /\ j<sy+first)
						tty.move(ex, j+y-first);
					xx := 0;
				end
				else if (xx < ek) do
					if (j > first /\ j<sy+first-1)
						tty.writec(text::len);
					xx := xx + 1;
				end
				len := len+1;
			end
			redraw := 0;
		end
		if (ro) do
			tty.move(x, y);
			return 0;
		end
		s0 := extract(text, off[pos], RECORDSIZE, buffer);
		k := editline(ex, y+pos+1-first, buffer, ek, RECORDSIZE-len-2,
			@mf, allowlc);
		if (mf) do
			delta := insert(text, off[pos], len, buffer, s0);
			for (j=pos+1, nf) off[j] := off[j] + delta;
			len := len + delta;
		end
		ie (k = ttyctl.K_CR \/ k = ttyctl.K_DOWN \/ k = 'N'-'@') do
			pos := pos+1;
			if (pos >= nf) do
				pos := 0;
				redraw := first \= 0;
				first := 0;
			end
			if (pos >= first+nv) do
				first := nf-nv;
				redraw := 1;
			end
		end
		else ie (k = ttyctl.K_UP \/ k = 'P'-'@') do
			pos := pos-1;
			if (pos < 0) do
				pos := nf-1;
				first := nf-nv;
				redraw := first \= 0;
			end
			if (pos < first) do
				first := 0;
				redraw := 1;
			end
		end
		else ie (k = ttyctl.K_F1) do
			edithelp();
			tty.color(C_background); tty.clear();
			ie (recno \= -1)
				dbinfo(recno, 1);
			else
				hintbar(Ymax-2, Lasthint);
			redraw := 1;
		end
		else if (k = 'Y'-'@') do
			redraw := 1;
		end
		if (allowlc) do
			ie (k = 'O'-'@' \/ k = '\\'-'@') do
				insfield(text, pos, "");
				redraw := 1;
			end
			else if (k = 'D'-'@') do
				text::len := '\n';
				delfield(text, pos);
				redraw := 1;
			end
		end
		j := 0;
		while (ekeys[j] \= %1) do
			if (k = ekeys[j]) return k;
			j := j+1;
		end
	end
end

dont(msg) do var m[2];
	m[0] := msg;
	m[1] := %1;
	info(%1, %1, m, [ (C_infoframe), (C_infotext) ]);
	hintbar(Ymax-2, "Press [ESC]");
	getkey();
	return 0;
end

NYI() do
	info(%1, %1, [ "Not yet implemented -- press ENTER", %1 ],
		[ (C_alert), (C_alert) ]);
	getkey();
end

killbuffer(buffer, nf) do var i;
	for (i=0, nf) buffer::i := '\n';
	for (i=i, RECORDSIZE) buffer::i := '-';
	buffer::(RECORDSIZE-1) := '\n';
end

normalize(buffer) do
	var	i, j;
	var	nlc;

	nlc := 0;
	j := 0;
	for (i=0, RECORDSIZE-1) do
		if (buffer::i = '\n') do
			nlc := nlc+1;
			while (i < RECORDSIZE-1 /\ buffer::(i+1) = '\n')
				i := i+1;
		end
		buffer::j := buffer::i;
		j := j+1;
	end
	while (j < RECORDSIZE-1) do
		buffer::j := '-';
		j := j+1;
	end
	buffer::j := '\n';
	return nlc;
end

settags(n) do var i;
	ie (n=2)
		for (i=1, Nrecords+1) Tagtbl::i := \Tagtbl::i;
	else ie (n=1)
		for (i=1, Nrecords+1) Tagtbl::i := %1;
	else
		for (i=0, RECORDMAX) Tagtbl::i := 0;
	Ntagged := 0;
	for (i=1, Nrecords+1)
		if (Tagtbl::i) Ntagged := Ntagged+1;
	SavedLimited := 0;
end

explain(error) do var m, msgs, k;
	hintbar(Ymax-2, 0);
	msgs := [
		"Unknown error",
		"Could not open file",
		"Magic match failed",
		"Invalid database header",
		"Corrupt index",
		"File creation failed" ];
	if (error < ERRMAX \/ error > %1) error := 0;
	m := [
		0,
		"",
		"Press [ESC] to continue",
		%1 ];
	m[0] := msgs[-error];
	info(%1, %1, m, [ (C_infoframe), (C_infotext) ]);
	while (1) do
		k := getkey();
		if (k = ttyctl.K_ESC \/ k = ':') leave;
	end
end

iofault(proc, arg) do
	tty.color(C_background); tty.clear();
	info(%1, %1, [
		"/// A fatal I/O error has occured.   ///",
		"/// The database will shut down now. ///",
		"",
		"Please write down the below error code",
		"and then contact the maintainer of this",
		"program.",
		"",
		"DO NOT start the database program again",
		"before the reason for this failure has",
		"been clarified.",
		"",
		"ERROR CODE:",
		"",
		"       Press [ESC] to shut down",
		%1 ], [ (C_alert), (C_alert) ]);
	ie (Xmax<80)
		tty.move(25, 13);
	else
		tty.move(33, 16);
	tty.writes(proc);
	tty.writec('(');
	tty.writes(pntoa(arg, 0, 0));
	tty.writec(')');
	while (getkey() \= ttyctl.K_ESC)
		;
	tty.color(ttyctl.F_GREY|ttyctl.B_BLACK);
	tty.move(0, Ymax-1); tty.clreol();
	tty.reset();
	tty.fini();
	sys.fini();
	halt 2;
end

reposition(fd, hpos, lpos, org) do var kmask;
	kmask := 16384;
	kmask := (kmask << 2) - 1;
	t.seek(fd, 0, T3X.SEEK_SET);
	while (hpos) do
		t.seek(fd, 16384, T3X.SEEK_FWD);
		t.seek(fd, 16384, T3X.SEEK_FWD);
		t.seek(fd, 16384, T3X.SEEK_FWD);
		t.seek(fd, 16384, T3X.SEEK_FWD);
		hpos := hpos-1;
	end
	t.seek(fd, lpos & kmask, T3X.SEEK_FWD);
end

dbreadraw(rn, buffer, ec) do var k;
	reposition(Dbfd, rn>>6, rn<<10, 0);
	k := t.read(Dbfd, buffer, RECORDSIZE);
	if (k = RECORDSIZE) return 0;
	if (\ec /\ k < 1) return %1;
	iofault("dbreadraw", rn);
end

dbwriteraw(rn, buffer) do
	reposition(Dbfd, rn>>6, rn<<10, 0);
	if (t.write(Dbfd, buffer, RECORDSIZE) \= RECORDSIZE)
		iofault("dbwriteraw", rn);
end

lowcase(s) do var c, i;
	i := 0;
	while (s::i) do
		c := s::i;
		if ('A' <= c /\ c <= 'Z') c := c+32;
		s::i := c;
		i := i+1;
	end
	return i;
end

dbcompare(key, rec) do var k, n1, n2;
	n1 := 0;
	n2 := 0;
	for (k=0, KEYLEN) do
		if (key::k = '\n') n1 := n1+1;
		if (rec::k = '\n') n2 := n2+1;
		if (n1>=Nfields \/ n2>=Nfields) leave;
	end
	return t.memcomp(key, rec, k);
end

dbinsert(rc, rn, nrc) do
	var	i;
	var	x;
	var	nx;
	var	rckey[KEYLEN];

	if (\rn) return nx;
	nx := 0;
	t.memcopy(rckey, rc, KEYLEN);
	lowcase(rckey);
	while (1) do
		x := @Index[nx*NDXLEN];
		if (nx >= nrc-1) leave;
		if (dbcompare(x, rckey) > 0) leave;
		nx := nx+1;
	end
	if (nx < nrc) do
		for (i=nrc+1, nx+1, %1) Tagtbl::i := Tagtbl::(i-1);
		t.memcopy(@x[NDXLEN], x, (NDXLEN<<Nxbits)*(nrc-nx));
	end
	Tagtbl::(nx+1) := 0;
	for (i=0, KEYLEN) x::i := rc::i;
	x::i := 0;
	lowcase(x);
	x[I_rec] := rn;
	return nx;
end

dbkillndx() do var ipath::PATHLEN+1;
	str.copy(ipath, Database);
	strcat(ipath, ".x");
	t.remove(ipath);
end

dbindex() do
	var	k, i, j;
	var	ifd, y;
	var	ipath::PATHLEN+1;

	y := Xmax<80-> 6: 9;
	if (Nrecords < 1) return 0;
	str.copy(ipath, Database);
	strcat(ipath, ".x");
	ifd := t.open(ipath, T3X.OREAD);
	ie (ifd < 0) do
		info(%1, y, [ 
			"Re-indexing the database: ___  of ___  done", %1 ],
			[ (C_infoframe), (C_infotext) ]);
		tty.move(Xmax<80->44:52, y+1);
		tty.writes(pntoa(Nrecords, 3, '_'));
		k := NDXLEN*Nrecords<<Nxbits;
		for (i=0, k) Index::i := 0;
		j := 0;
		i := 0;
		while (1) do
			if (dbreadraw(i, Record, 0) < 0) leave;
			tty.move(Xmax<80->36:44, y+1);
			tty.writes(pntoa(i, 3, '_'));
			if (Record::(RECORDSIZE-2) = '-') do
				dbinsert(Record, i, j);
				j := j+1;
			end
			i := i+1;
		end
		Rawcount := i;
		return 0;
	end
	else do
		k := NDXLEN*Nrecords<<Nxbits;
		k := k - t.read(ifd, Index, k);
		k := k - (t.read(ifd, @i, 1) > 0);
		t.close(ifd);
		return k-> %1: 0;
	end
end

dbmaketags(desc, off) do var i, j, k;
	i := off;
	j := 0;
	k := i;
	Vfields := 0;
	while (i<RECORDSIZE) do
		if (desc::i = '\n') do
			desc::i := 0;
			Taglist[j] := @desc::(k+1);
			Vlist[j] := desc::k = '+';
			if (desc::k = '+') Vfields := Vfields+1;
			j := j+1;
			k := i+1;
		end
		i := i+1;
		if (j >= Nfields) leave;
	end
	Taglist[j] := %1;
	return j;
end

dbcvtdesc() do var i, j, k, nf, chg;
	i := 6;
	nf := (Descriptor::i-'0') * 10 + Descriptor::(i+1)-'0';
	i := gotopos(Descriptor, 3);
	k := i;
	j := 0;
	chg := 0;
	while (i < RECORDSIZE /\ j <= nf) do
		if (Descriptor::i = '\n') do
			if (Descriptor::k \= '-' /\ Descriptor::k \= '+') do
				t.memcopy(@Descriptor::(k+1),
					@Descriptor::k, RECORDSIZE-k-1);
				Descriptor::k := '+';
				chg := 1;
				i := i+1;
				if (j = nf) leave;
			end
			k := i+1;
			j := j+1;
		end
		i := i+1;
	end
	if (chg) dbwriteraw(0, Descriptor);
end

dbopen(name) do
	var	i, j;
	var	ifd;
	var	dpath::PATHLEN+1, ipath::PATHLEN+1;

	str.copy(Database, name);
	str.copy(dpath, name);
	strcat(dpath, ".db");
	Dbfd := t.open(dpath, T3X.ORDWR);
	if (Dbfd < 0) return EOPEN;
	if (t.read(Dbfd, Descriptor, RECORDSIZE) \= RECORDSIZE) do
		t.close(Dbfd);
		Dbfd := %1;
		return EIHDR;
	end
	dbcvtdesc();
	Descriptor::5 := 0;
	if (str.comp(Descriptor, "NMH00")) do
		t.close(Dbfd); Dbfd := %1;
		return EMAGIC;
	end
	i := 6;
	Nfields := (Descriptor::i-'0') * 10 + Descriptor::(i+1)-'0';
	i := i+2;
	Nrecords := (Descriptor::i-'0') * 100 +
			(Descriptor::(i+1)-'0') * 10 +
			(Descriptor::(i+2)-'0');
	i := i+3;
	Rawcount := (Descriptor::i-'0') * 100 +
			(Descriptor::(i+1)-'0') * 10 +
			(Descriptor::(i+2)-'0');
	i := i+3;
	if (\Descriptor::i \/ Descriptor::i \= '\n' \/ i \= 14) do
		t.close(Dbfd); Dbfd := %1;
		return EIHDR;
	end
	if (	Nrecords > RECORDMAX \/ Nrecords < 0 \/ 
		Rawcount > RECORDMAX+1 \/ Rawcount < 0
	) do
		t.close(Dbfd); Dbfd := %1;
		return EIHDR;
	end
	i := i+1;
	Title := @Descriptor::15;
	while (Descriptor::i /\ Descriptor::i \= '\n') i := i+1;
	if (\Descriptor::i) do
		t.close(Dbfd); Dbfd := %1;
		return EIHDR;
	end
	Descriptor::i := 0; i := i+1;
	j := dbmaketags(Descriptor, i);
	if (j < Nfields) do
		t.close(Dbfd); Dbfd := %1;
		return EIHDR;
	end
	settags(0);
	if (dbindex() < 0) do
		dbkillndx();
		if (dbindex() < 0) do
			t.close(Dbfd); Dbfd := %1;
			return EINDEX;
		end
	end
	dbkillndx();
	return Dbfd;
end

lookup(rn) return Index[(rn-1)*NDXLEN + I_rec];

dbread(rn, buffer) do
	rn := lookup(rn);
	dbreadraw(rn, buffer, 1);
end

dbwrite(rn, buffer) do
	rn := lookup(rn);
	dbwriteraw(rn, buffer);
end

dbdelete(rn, phys) do var i, x;
	if (phys) do
		dbread(rn, Record);
		Record::(RECORDSIZE-2):= 'D';
		dbwrite(rn, Record);
	end
	for (i=rn, Nrecords)
		Tagtbl::i := Tagtbl::(i+1);
	Tagtbl::(TAGTBLSIZE-1) := 0;
	rn := rn-1;
	x := @Index[rn*NDXLEN];
	t.memcopy(x, @x[NDXLEN], (NDXLEN<<Nxbits)*(Nrecords-rn));
	Nrecords := Nrecords-1;
end

dbsplit(rc, fields) do var i, nf;
	fields[0] := rc;
	nf := 1;
	for (i=0, RECORDSIZE) do
		if (rc::i = '\n') do
			fields[nf] := @rc::(i+1); nf := nf+1;
			rc::i := 0;
		end
		if (nf >= FIELDMAX) leave;
	end
	return nf;
end

dbupdate() do
	dbreadraw(0, Record, 1);
	Record::6 := Nfields / 10 + '0';
	Record::7 := Nfields mod 10 + '0';
	Record::8 := Nrecords / 100 + '0';
	Record::9 := Nrecords mod 100 / 10 + '0';
	Record::10 := Nrecords mod 10 + '0';
	Record::11 := Rawcount / 100 + '0';
	Record::12 := Rawcount mod 100 / 10 + '0';
	Record::13 := Rawcount mod 10 + '0';
	dbwriteraw(0, Record);
end

dbflushndx() do
	var	ifd;
	var	ipath::PATHLEN+1;
	var	k;

	if (Nrecords) do
		str.copy(ipath, Database);
		strcat(ipath, ".x");
		ifd := t.open(ipath, T3X.OWRITE);
		if (ifd < 0) return ECREAT;
		k := NDXLEN*Nrecords<<Nxbits;
		k := k - t.write(ifd, Index, k);
		if (k) iofault("dbflushndx", %1);
		t.close(ifd);
	end
	return 0;
end

dbclose() do
	dbupdate();
	t.close(Dbfd);
	return dbflushndx();
end

dbinfo(rn, full) do var i;
	tty.color(C_edittext);
	if (full) do
		tty.color(C_background);
		tty.move(0,Ymax-2);
		ie (Xmax < 80)
			tty.writes("\s\s\s\s");
		else
			tty.writes("\s\s\s\s\s\s\s\s\s");
		tty.color(C_edittext);
		tty.writes("\s\s");
		if (Limited) tty.color(C_limitind);
		tty.writes(Title);
		if (Limited) tty.color(C_edittext);
		for (i=str.length(Title), Xmax<80->26:30) tty.writec(' ');
		tty.writes("           ___ / ___ (___)  ");
		tty.color(C_background);
		ie (Xmax < 80)
			tty.writes("\s\s\s\s");
		else
			tty.writes("\s\s\s\s\s\s\s\s\s");
		tty.color(C_edittext);
		tty.move(Xmax<80->49:58, Ymax-2);
		tty.writes(pntoa(Nrecords, 3, '_'));
		tty.move(Xmax<80->54:63, Ymax-2);
		tty.writes(pntoa(Ntagged, 3, '_'));
	end
	tty.move(Xmax<80->43:52, Ymax-2); tty.writes(pntoa(rn, 3, '_'));
end

locate(fullmatch) do var x, i, k, nf;
	t.memcopy(Normrec, Record, RECORDSIZE);
	lowcase(Normrec);
	ie (fullmatch) do
		nf := 1;
		for (k=0, KEYLEN) do
			if (Normrec::k = '\n') do
				nf := nf+1;
				if (nf > Nfields) leave;
			end
		end
	end
	else do
		for (k=0, KEYLEN)
			if (Normrec::k = '\n') leave;
	end
	for (i=0, Nrecords) do
		x := @Index[i*NDXLEN];
		if (\t.memcomp(x, Normrec, k)) return i;
	end
	return %1;
end

dbedit(rn, ro) do
	var	k, i, esc;
	var	oldkey[KEYLEN], newkey[KEYLEN], orc, ck;

	dbinfo(0, 1);
	oldkey::KEYLEN := 0;
	while (1) do
		dbinfo(rn, 1);
		dbread(rn, Record);
		t.memcopy(oldkey, Record, KEYLEN);
		lowcase(oldkey);
		ie (ro) do
			edit(rn, %1, %1, 60, Taglist, Record, [ %1 ], 0, 1);
			k := getkey();
		end
		else do
			esc := [ ttyctl.K_ESC, 0, 0, 0, ttyctl.K_PGUP,
				ttyctl.K_PGDN, %1 ];
			esc[1] := 'R'-'@';
			esc[2] := 'V'-'@';
			esc[3] := 'X'-'@';
			k := edit(rn, %1, %1, 60, Taglist, Record, esc, 0, 0);
			ie (k = 'X'-'@') do
				dbread(rn, Record);
			end
			else do
				ck := locate(1);
				if (ck \= -1 /\ ck \= rn-1) do
					dont(
					"Key collision! Changes discarded");
					loop;
				end
				dbwrite(rn, Record);
			end
			t.memcopy(newkey, Record, KEYLEN);
			lowcase(newkey);
			if (dbcompare(oldkey, newkey)) do
				info(%1, %1, [ "Key change!", %1],
					[ (C_infoframe), (C_infotext) ]);
				orc := lookup(rn);
				dbdelete(rn, 0);
				rn := dbinsert(Record, orc, Nrecords+1) + 1;
				Nrecords := Nrecords+1;
			end
		end
		ie (k = ttyctl.K_ESC \/ k = ':') do
			leave;
		end
		else ie ((k = ttyctl.K_PGDN \/ k = 'V'-'@') /\
			rn < Nrecords
		) do
			rn := rn+1;
		end
		else if ((k = ttyctl.K_PGUP \/ k = 'R'-'@') /\ rn > 1) do
			rn := rn-1;
		end
	end
	return rn;
end

tagged() do var i, n;
	n := 0;
	for (i=1, Nrecords+1) if (Tagtbl::i) n := n+1;
	return n;
end

limitview() do var k, k2;
	if (\Ntagged) do
		dont("No records tagged -- limited view would be empty");
		return %1;
	end
	Limited := t.open("_NDXCOPY", T3X.OWRITE);
	if (Limited < 0) iofault("limitview", 1);
	k := NDXLEN*RECORDMAX;
	k := k<<Nxbits;
	k := k - t.write(Limited, Index, k);
	if (k) iofault("limitview", 2);
	k := TAGTBLSIZE;
	k := k - t.write(Limited, Tagtbl, k);
	if (k) iofault("limitview", 3);
	t.close(Limited);
	k2 := 0;
	for (k=0, Nrecords) do
		if (Tagtbl::(k+1)) do
			if (k \= k2) t.memcopy(@Index[k2*NDXLEN],
					@Index[k*NDXLEN], NDXLEN<<Nxbits);
			k2 := k2+1;
		end
	end
	Limited := Nrecords;
	SavedLimited := 0;
	Nrecords := k2;
	settags(0);
end

unlimitview() do var k;
	if (\Limited) return 0;
	Nrecords := Limited;
	Limited := t.open("_NDXCOPY", T3X.OREAD);
	if (Limited < 0) iofault("unlimitview", 1);
	k := NDXLEN*RECORDMAX;
	k := k<<Nxbits;
	k := k - t.read(Limited, Index, k);
	if (k) iofault("unlimitview", 2);
	k := TAGTBLSIZE;
	k := k - t.read(Limited, Tagtbl, k);
	if (k) iofault("unlimitview", 3);
	t.close(Limited);
	Limited := 0;
	SavedLimited := 0;
	Ntagged := tagged();
	t.remove("_NDXCOPY");
	return Nrecords;
end

limitedview() do var k;
	ie (SavedLimited \/ Limited) do
		unlimitview();
		SavedLimited := 0;
	end
	else do
		limitview();
	end
	k := locate(1);
	return k=%1-> 1: k+1;
end

addrecord(nx) do
	if (Nrecords >= RECORDMAX) do
		dont("Implementation limit: too many records");
		return -nx;
	end
	if (locate(1) \= %1) do
		dont("Key collision! Record discarded");
		return -nx;
	end
	nx := dbinsert(Record, Rawcount, Nrecords+1)+1;
	dbwriteraw(Rawcount, Record);
	Nrecords := Nrecords+1;
	Rawcount := Rawcount+1;
	dbupdate();
	return nx;
end

newrecord(nx) do var k, esc, nnx;
	while (1) do
		tty.color(C_background); tty.clear();
		killbuffer(Record, Nfields);
		hintbar(Ymax-2, 
			"Enter new record, [PGDN] = next, [ESC] = done");
		esc := [ ttyctl.K_ESC, ttyctl.K_PGDN, 0, %1 ];
		esc[2] := 'F'-'@';
		k := edit(-1, %1, %1, 60, Taglist, Record, esc, 0, 0);
		if (Record::0 = '\n') return nx;
		nnx := addrecord(nx);
		if (nnx < 0) return -nnx;
		nx := nnx;
		if (k \= ttyctl.K_PGDN /\ k \= 'F'-'@') leave;
	end
	return nx;
end

delrecords(rn) do var m, n, k, i;
	n := tagged();
	ie (n) do
		m := "About to delete ___ tagged records.";
		m::(16) := n / 100 + '0';
		m::(16+1) := n mod 100 / 10 + '0';
		m::(16+2) := n mod 10 + '0';
	end
	else do
		m := "Delete the selected record?";
	end
	k := prompt(%1, %1, 0, m, "Delete", "Cancel");
	if (k \= 1) return 0;
	ie (n) do
		for (i=Nrecords, 0, %1) do
			if (Tagtbl::i) dbdelete(i, 1);
		end
	end
	else do
		dbdelete(rn, 1);
	end
	settags(0);
	dbupdate();
end

allempty(rc) do var i;
	for (i=0, Nfields)
		if (rc::i \= '\n') return 0;
	return 1;
end

match(rec, pat) do var i, j, k, k2, m, n, delta, off, fc;
	i := 0; j := 0;
	for (fc=0, Nfields) do
		m := j;
		n := i;
		while (pat::j \= '\n') j := j+1;
		while (rec::i \= '\n') i := i+1;
		k := j-m;
		k2 := i-n;
		delta := k2-k+1;
		ie (delta > 0) do
			for (off=0, delta)
				if (\t.memcomp(pat+m, rec+n+off, k))
					leave;
			if (off = delta) return 0;
		end
		else do
			return 0;
		end
		i := i+1;
		j := j+1;
	end
	return 1;
end

selectrecords(add, rm) do
	var	rn, nm, ot;
	var	y;

	y := Xmax<80-> 9: 12;
	tty.color(C_background); tty.clear();
	killbuffer(Auxrec, Nfields);
	hintbar(Ymax-2,
		"Enter selection criteria. empty=anything. [ESC]=done");
	edit(-1, %1, %1, 60, Taglist, Auxrec, [ ttyctl.K_ESC, %1 ], 0, 0);
	lowcase(Auxrec);
	if (allempty(Auxrec)) do
		if (prompt(%1, %1, 1,
			"No criteria have been specified",
			rm-> "Unselect all": "Select all",
			"Never mind") \= 1)
				return 0;
		settags(rm-> 0: 1);
		return 0;
	end
	hintbar(Ymax-2, "Press [ESC] to interrupt");
	info(%1, %1, [ "Searching: ___", %1 ],
		[ (C_infoframe), (C_infotext) ]);
	if (\(add|rm)) settags(0);
	nm := 0;
	for (rn=1, Nrecords+1) do
		tty.move(Xmax<80->35:43, y); tty.writes(pntoa(rn, 3, '_'));
		dbread(rn, Record);
		lowcase(Record);
		if (match(Record, Auxrec)) do
			ot := Tagtbl::rn;
			ie (rm) do
				Tagtbl::rn := 0;
				if (ot) Ntagged := Ntagged-1;
			end
			else do
				Tagtbl::rn := 1;
				if (\ot) Ntagged := Ntagged+1;
			end
			nm := nm+1;
		end
		if (tty.query()) do
			if (tty.readc() = ttyctl.K_ESC) do
				if (\(add|rm)) settags(0);
				return 0;
			end
		end
	end
	if (O_hints) do
		hintbar(Ymax-2, "Search completed. Press [ENTER]");
		ie (nm) do
			info(%1, %1, [ "___ matches", %1 ],
				[ (C_infoframe), (C_infotext) ]);
			tty.move(Xmax<80->26:34, y);
			tty.writes(pntoa(nm, 3, '_'));
		end
		else do
			info(%1, %1, [ "No matches", %1 ],
				[ (C_infoframe), (C_infotext) ]);
		end
		getkey();
	end
end

input(name, hint, buffer, default) do var m;
	tty.color(C_background); tty.clear();
	hintbar(Ymax-2, hint);
	killbuffer(buffer, 1);
	if (default \= %1) insfield(buffer, 0, default);
	m := [ 0, %1 ]; m[0] := name;
	return edit(-1, %1, %1, 60, m, buffer,
		[ ttyctl.K_CR, ttyctl.K_ESC, %1 ], 0, 0) \= ttyctl.K_ESC;
end

quicklocate(rn) do var x, i, k;
	if (\input("Locate",
	"Enter key (first field) of desired record", Record, %1))
		return rn;
	if (Record::0 = '\n') return rn;
	i := locate(0);
	if (i = %1) do
		dont("No matches");
		return rn;
	end
	return i+1;
end

selections(rn) do var i;
	i := menu(%1, %1, 0, [
		"Select records        [S]",
		"Add selections        [A]",
		"Remove selections     [R]",
		"Unselect all          [U]",
		"Swap selections       [W]",
		"Limited view on/off   [L]",
		"Quick locate          [/]",
		%1 ],
		[ 's', 'a', 'r', 'u', 'w', 'l', '/' ], [
		"Select records matching specific criteria",
		"Select additional records",
		"Unselect records matching specific criteria",
		"Cancel any active selections",
		"Tag untagged records and vice versa",
		"Enable or disable hiding of unselected record",
		"Locate a record by its key field entry"
		], C_browsetext);
	ie (i=0) selectrecords(0, 0);
	else ie (i=1) selectrecords(1, 0);
	else ie (i=2) selectrecords(0, 1);
	else ie (i=3) settags(0);
	else ie (i=4) settags(2);
	else ie (i=5) rn := limitedview();
	else if (i=6) rn := quicklocate(rn);
	return rn;
end

newfile(name, hint, errmsg, suffix, buffer) do
	var	i, fd, k, m;
	var	path::NAMELEN+4;

	while (1) do
		if (\input(name, hint, Record, %1)) return 0;
		if (Record::0 = '\n') return 0;
		i := extract(Record, 0, PATHLEN, buffer);
		buffer::i := 0;
		str.copy(path, buffer);
		path::FNAMELEN := 0;
		strcat(path, suffix);
		fd := t.open(path, T3X.OREAD);
		if (fd >= 0) do
			t.close(fd);
			tty.color(C_background); tty.clear();
			m := [ 0, %1]; m[0] := errmsg;
			info(%1, 5, m, [ (C_infoframe), (C_infotext) ]);
			k := menu(%1, %1, 0, [
				"  Try a different name  ",
				"Delete the existing file",
				"        Give up         ",
				%1 ],
				[ 0, 0 ], 0, C_background);
			tty.color(C_background); tty.clear();
			if (k = 1) leave;
			if (\k) loop;
			return 0;
		end
		leave;
	end
	return 1;
end

updateconf() do
	if (Confpath::0 = 0) do
		ie (t.getenv("HOME", Confpath, PATHLEN-10) > 0) do
			strcat(Confpath, "/");
			strcat(Confpath, O_dosflag-> "node.rc":
				".noderc");
		end
		else do
			str.copy(Confpath, "node.rc");
		end
	end
	Cnf.save(Confpath,
		[ "# This is a Node 3.4 config file", "", 0 ]);
end

writetagfile(name) do var fd, r;
	fd := t.open(name, T3X.OWRITE);
	r := t.write(fd, Tagtbl, TAGTBLSIZE-1);
	t.close(fd);
	return r \= TAGTBLSIZE-1 -> -1 : 0;
end

reportwriter() do var tpath::PATHLEN+5, rgpath::PATHLEN+5, r;
	if (\Ntagged) do
		dont("No records tagged for reporting");
		return;
	end
	str.copy(tpath, Database);
	strcat(tpath, ".tg");
	if (writetagfile(tpath) < 0) do
		dont("Could not export tag table");
		return;
	end
	updateconf();
	str.copy(rgpath, O_rgpath);
	if (O_dosflag) strcat(rgpath, ".exe");
	tty.color(ttyctl.F_GREY|ttyctl.B_BLACK);
	tty.clear();
	tty.mode(0);
	dbflushndx();
	r := sys.spawn(rgpath, [ (Database), (Confpath), 0 ],
		system.SPAWN_WAIT);
	t.remove(tpath);
	dbkillndx();
	tty.mode(1);
	tty.color(C_background);
	tty.clear();
	if (r) dont("Failed to run report generator -- check config");
end

copyback(insf, delf) do
	var	name1[PATHLEN], name2[PATHLEN];
	var	tfd, k;
	var	n;
	var	y;

	y := Xmax<80-> 9: 12;
	str.copy(name1, Database);
	strcat(name1, ".db$");
	tfd := t.open(name1, T3X.OWRITE);
	if (tfd < 0) do
		dont("Cannot create copy file");
		return 0;
	end
	dbupdate();
	reposition(Dbfd, 0, 0, 0);
	n := 0;
	info(%1, %1, [ "Copyback: ___ / ___", %1 ],
		[ (C_infoframe), (C_infotext) ]);
	tty.move(Xmax<80->38:46, y); tty.writes(pntoa(Nrecords, 3, '_'));
	while (1) do
		tty.move(Xmax<80->32:40, y); tty.writes(pntoa(n, 3, '_'));
		k := t.read(Dbfd, Record, RECORDSIZE);
		if (\k) leave;
		if (n) do
			ie (insf \= %1)
				insfield(Record, insf, "");
			else if (delf \= %1)
				delfield(Record, delf);
		end
		if (k \= RECORDSIZE) iofault("copyback", 1);
		if (t.write(tfd, Record, RECORDSIZE) \= RECORDSIZE)
			iofault("copyback", 2);
		n := n+1;
	end
	t.close(tfd);
	t.close(Dbfd);
	str.copy(name2, Database);
	strcat(name2, ".db");
	if (t.remove(name2) < 0) iofault("copyback", 3);
	if (t.rename(name1, name2) < 0) iofault("copyback", 4);
	Dbfd := t.open(name2, T3X.ORDWR);
	if (Dbfd < 0) iofault("copyback", 5);
end

insertfield() do var pos;
	if (Nfields >= FIELDMAX) do
		dont("Implementation limit: too many fields");
		return 0;
	end
	Taglist[Nfields] := "\s\s\s\s\s\s\s\s\s\s";
	Taglist[Nfields+1] := %1;
	hintbar(Ymax-2, "Select the position of the new field");
	pos := menu(5, Xmax<80->2:3, 0, Taglist, [ 0 ], 0, C_browsehead);
	Taglist[Nfields] := %1;
	if (pos < 0) return 0;
	if (\pos) do
		dont("Cannot insert a new key field");
		return 0;
	end
	if (\input("Field name",
	"Enter a name describing the new field", @Auxrec::1, %1))
		return 0;
	if (Auxrec::1 = '\n') return 0;
	Auxrec::0 := '+';
	extract(Auxrec, 0, NAMELEN, Auxrec);
	copyback(pos, %1);
	dbupdate();
	dbreadraw(0, Descriptor, 1);
	insfield(Descriptor, pos+3, Auxrec);
	dbwriteraw(0, Descriptor);
	Nfields := Nfields+1;
	pos := gotopos(Descriptor, 3);
	Descriptor::(pos-1) := 0;
	dbmaketags(Descriptor, pos);
end

deletefield() do
	var	pos;
	var	m;

	hintbar(Ymax-2, "Select the field to remove");
	pos := menu(5, Xmax<80->2:3, 0, Taglist, [ 0 ], 0, C_browsehead);
	fbox(5, Xmax<80->2:3, Xmax/2-1, Ymax-4);
	if (pos < 0) return 0;
	if (\pos) do
		dont("Cannot delete the key field");
		return 0;
	end
	if (O_warnings) do
		m := [ "All information currently stored",
			"in the field named",
			"",
			0,
			"",
			"will be lost in ALL records.", %1 ];
		m[3] := Taglist[pos];
		info (%1, Xmax<80->1:5, m, [ (C_infoframe), (C_infotext) ]);
		if (prompt(%1, Xmax<80->10:15, 1,
			"Remove this field anyway?",
			"Remove", "Cancel") \= 1)
				return 0;
		tty.color(C_background); tty.clear();
		tty.color(C_browsehead);
		fbox(5, Xmax<80->2:3, Xmax/2-1, Ymax-4);
	end
	copyback(%1, pos);
	dbupdate();
	dbreadraw(0, Descriptor, 1);
	delfield(Descriptor, pos+3);
	dbwriteraw(0, Descriptor);
	Nfields := Nfields-1;
	pos := gotopos(Descriptor, 3);
	Descriptor::(pos-1) := 0;
	dbmaketags(Descriptor, pos);
end

renamefield() do var pos;
	hintbar(Ymax-2, "Select the field to rename");
	pos := menu(5, Xmax<80->2:3, 0, Taglist, [ 0 ], 0, C_browsehead);
	if (pos < 0) return 0;
	if (\input("Field name",
	"Edit the field name. [ENTER]=change, [ESC]=back", @Record::1,
		Taglist[pos]))
			return 0;
	if (Record::1 = '\n') return 0;
	Record::0 := '+';
	extract(Record, 0, NAMELEN, Record);
	dbreadraw(0, Descriptor, 1);
	delfield(Descriptor, pos+3);
	insfield(Descriptor, pos+3, Record);
	dbwriteraw(0, Descriptor);
	pos := gotopos(Descriptor, 3);
	Descriptor::(pos-1) := 0;
	dbmaketags(Descriptor, pos);
end

editstruct() do var i;
	while (1) do
		tty.color(C_background); tty.clear();
		tty.color(C_browsehead);
		fbox(5, Xmax<80->2:3, Xmax/2-1, Ymax-4);
		for (i=0, Nfields) do
			tty.move(7, (Xmax<80->3:4)+i); tty.writes(Taglist[i]);
		end
		i := menu(%15, %1, 0, [
		"Insert field   [I]",
		"Remove field   [R]",
		"Rename field   [N]",
		"Done              ",
		%1 ],
		[ 'i', 'r', 'n' ], [
		"Add a new field and fill with empty values",
		"Delete an existing field (contents will be lost)",
		"Rename an existing field (no change to entries)",
		"Return to the browser"
		], C_background);
		tty.color(C_browsehead);
		fbox(5, Xmax<80->2:3, Xmax/2-1, Ymax-4);
		ie (i = 3 \/ i < 0) leave;
		else ie (i = 0) insertfield();
		else ie (i = 1) deletefield();
		else if (i = 2) renamefield();
	end
end

updateview(desc, off, vl) do var i, j;
	j := 0;
	for (i=off, RECORDSIZE) do
		if (desc::(i-1) = '\n') do
			desc::i := vl[j]-> '+': '-';
			j := j+1;
			if (j >= Nfields) leave;
		end
	end
end

changeview() do
	var	i, j, pos, x, y, tx;
	var	buf::RECORDMAX+257, bp, flds[FIELDMAX+1], fp, k;

	x := Xmax/2-25;
	y := Ymax/2-9;
	tty.color(C_background); tty.clear();
	tty.color(C_browsehead);
	fbox(x, y, x+50, y + (Ymax > 18-> 18: 15));
	pos := 0;
	tx := 0;
	for (i=0, Nfields) do
		j := str.length(Taglist[i]);
		if (j > tx) tx := j;
	end
	tx := tx+5;
	hintbar(Ymax-2, "[ENTER] = toggle view, [ESC] = done");
	while (1) do
		bp := 0;
		fp := 0;
		for (i=0, Nfields) do
			flds[fp] := @buf::bp;
			t.memcopy(@buf::bp,
				(i = 0->
					"key     - ":
				Vlist[i]->
					"visible - ":
					"hidden  - "), 11);
			bp := bp+10;
			k := str.length(Taglist[i])+1;
			t.memcopy(@buf::bp, Taglist[i], k);
			fp := fp+1;
			bp := bp+k;
		end
		flds[fp] := %1;
		pos := menu(x, y, pos, flds, [ 0 ], 0, C_browsehead);
		if (pos < 0) leave;
		ie (pos = 0)
			loop;
		else ie (Vlist[pos])
			Vfields := Vfields-1;
		else
			Vfields := Vfields+1;
		if (\Vfields) do
			Vfields := 1;
			loop;
		end
		Vlist[pos] := \Vlist[pos];
	end
	tty.color(C_background); tty.clear();
	dbreadraw(0, Descriptor, 1);
	pos := gotopos(Descriptor, 3);
	updateview(Descriptor, pos, Vlist);
	dbwriteraw(0, Descriptor);
	pos := gotopos(Descriptor, 3);
	Descriptor::(pos-1) := 0;
	dbmaketags(Descriptor, pos);
end

packdb() do
	var	name1[PATHLEN], name2[PATHLEN];
	var	tfd, dfd, k;
	var	n, kept, m;
	var	y;

	y := Xmax<80-> 6: 9;
	if (O_warnings) do
		info(%1, Xmax<80->2:5, [
		"When the database is packed, all records which",
		"where previously deleted will irreversibly be",
		"lost. The space allocated by deleted records",
		"will be released thereby.",
		"",
		"Packing large databases may take some time,",
		"since all records will have to be re-indexed.",
		%1 ], [ (C_infoframe), (C_infotext) ]);
		if (prompt(%1, Xmax<80->10:15, 1,
			"Really pack the database now?",
			"Pack", "Cancel") \= 1)
				return 0;
	end
	tty.color(C_background); tty.clear();
	tty.color(C_browsetext); fbox(10, 2, Xmax-10, Ymax-3);
	tty.move(Xmax<80->22:30, 4); tty.writes("P a c k i n g . . .");
	str.copy(name1, Database);
	strcat(name1, ".db$");
	tfd := t.open(name1, T3X.OWRITE);
	if (tfd < 0) do
		dont("Cannot create copy file");
		return 0;
	end
	dfd := t.open("_DELETED", T3X.OWRITE);
	if (dfd < 0) do
		dont("Cannot create _DELETED database");
		return 0;
	end
	dbupdate();
	reposition(Dbfd, 0, 0, 0);
	n := 0;
	kept := 0;
	info(%1, y, [ "Packing: ___ / ___", %1 ],
		[ (C_infoframe), (C_infotext) ]);
	tty.move(Xmax<80->37:45, y+1); tty.writes(pntoa(Nrecords, 3, '_'));
	while (1) do
		tty.move(Xmax<80->31:39, y+1); tty.writes(pntoa(n, 3, '_'));
		k := t.read(Dbfd, Record, RECORDSIZE);
		if (\k) leave;
		if (k \= RECORDSIZE) iofault("packdb", 1);
		ie (Record::(RECORDSIZE-2) = 'D') do
			if (t.write(dfd, Record, RECORDSIZE) \= RECORDSIZE)
				iofault("packdb", 2);
		end
		else do
			if (t.write(tfd, Record, RECORDSIZE) \= RECORDSIZE)
				iofault("packdb", 3);
			kept := kept+1;
		end
		n := n+1;
	end
	t.close(tfd);
	t.close(dfd);
	if (n = kept) t.remove("_DELETED");
	dbclose();
	str.copy(name2, Database);
	strcat(name2, ".db");
	if (t.remove(name2) < 0) iofault("packdb", 4);
	if (t.rename(name1, name2) < 0) iofault("packdb", 5);
	str.copy(name1, Database);
	strcat(name1, ".x");
	t.remove(name1);
	dbopen(Database);
	if (Dbfd < 0) iofault("packdb", 6);
	Rawcount := kept;
	dbupdate();
	m := [ "___ records salvaged", %1 ];
	t.memcopy(m[0], pntoa(n-kept, 3, '_'), 3);
	info(%1, Xmax<80->11:14, m, [ (C_infoframe), (C_infotext) ]);
	tty.color(C_browsetext); tty.move(Xmax<80->22:30, 4);
	tty.writes("\s\s\s\s\s\s\s\s\s\s\s\s\s\s\s\s\s\s\s\s");
	hintbar(Ymax-2, "Press [ENTER] to return to the browser");
	getkey();
end

browserhelp() do
	help(%1, Xmax<80->1:%1, [
	"Browser keys -- ~[^X]~ denotes ~[control]~ + ~[X]",
	"\s",
	"~[^N][^P]~   next/prev. record  (or ~[Up]~/~[Down]~)",
	"~[^F][^B]~   next/prev. page    (or ~[PgUp]~/~[PgDn]~)",
	"~[^A][^E]~   first/last record  (or ~[Home]~/~[End]~)",
	"~[ENTER]~    edit current record",
	"~[SPACE]~    tag/untag current record",
	"~[INS][DEL]~ insert new records / delete records",
	"~[S][/]~     select records / quick locate",
	"~[L]~        toggle limited view",
	"~[E]~        set options",
	"~[ESC]~      open main menu (in menus also ~[:]~)",
	%1]);
	hintbar(Ymax-2, "Press [ESC] to return to the browser");
	getkey();
	clrhelp();
end

dbmrginfo(merged, skipped, bogous) do
	info (%1, 5, [
	"___ records merged",
	"___ records skipped",
	"___ records discarded",
	%1], [ (C_infoframe), (C_infotext) ]);
	tty.move(Xmax<80->21:29, 6); tty.writes(pntoa(merged, 3, '_'));
	tty.move(Xmax<80->21:29, 7); tty.writes(pntoa(skipped, 3, '_'));
	tty.move(Xmax<80->21:29, 8); tty.writes(pntoa(bogous, 3, '_'));
	hintbar(Ymax-2, "Merging done - press [ENTER]");
	getkey();
end

dbmerge(fd, skiphdr) do
	var	i, cp, ep, ptr;
	var	nmerged, nbogous, nskipped, ntotal;
	var	quoted, fc, rn;

	cp := 0;
	ep := 0;
	nmerged := 0;
	nbogous := 0;
	nskipped := 0;
	ntotal := 0;
	ptr := 0;
	quoted := 0;
	fc := 1;
	tty.color(C_background); tty.clear();
	tty.color(C_browsetext); fbox(10, 2, Xmax-10, Ymax-3);
	info(%1, 5, [ "Merging: ___", %1],
		[ (C_infoframe), (C_infotext) ]);
	settags(0);
	while (1) do
		if (cp >= ep) do
			ep := t.read(fd, Auxrec, RECORDSIZE*2);
			if (ep < 1) leave;
			cp := 0;
		end
		ie (Auxrec::cp = '"') do
			quoted := \quoted;
		end
		else ie (Auxrec::cp = ',' /\ \quoted) do
			if (ptr < RECORDSIZE-1) do
				Record::ptr := '\n';
				ptr := ptr+1;
				fc := fc+1;
			end
		end
		else ie (Auxrec::cp = '\r') do
			! ignore
		end
		else ie (Auxrec::cp = '\n') do
			tty.move(Xmax<80->34:42, 6);
			ntotal := ntotal+1;
			tty.writes(pntoa(ntotal, 3, '_'));
			ie (quoted \/ fc \= Nfields) do
				nbogous := nbogous+1;
			end
			else do
				Record::ptr := '\n';
				for (i=ptr+1, RECORDSIZE) Record::i := '-';
				Record::(RECORDSIZE-1) := '\n';
				Record::RECORDSIZE:= 0;
				ie (locate(1) = %1 /\ \skiphdr) do
					rn := addrecord(1);
					if (rn < 0) leave;
					Tagtbl::rn := %1;
					Ntagged := Ntagged+1;
					nmerged := nmerged+1;
				end
				else do
					nskipped := nskipped+1;
				end
			end
			skiphdr := 0;
			ptr := 0;
			quoted := 0;
			fc := 1;
		end
		else do
			ie (ptr >= RECORDSIZE-1) do
				if (ptr = RECORDSIZE) nbogous := nbogous+1;
			end
			else do
				if (Auxrec::cp = '\\') cp := cp+1;
				Record::ptr := Auxrec::cp;
				ptr := ptr+1;
			end
		end
		cp := cp+1;
	end
	dbmrginfo(nmerged, nskipped, nbogous);
end

import() do var fd, i;
	if (O_warnings) do
		info(%1, Xmax<80->2:6, [
		"This option will import the content of a",
		"CSL (Comma Separated List) file and copy",
		"its records into the currently opened",
		"database.",
		"When a record with the same key as a CSL",
		"record already exists in the database, that",
		"record will not be merged in.",
		%1],
		[ (C_infoframe), (C_infotext) ]);
		if (prompt(%1, Xmax<80->10:14, 0,
			"Merge databases?",
			"Merge", "Cancel") \= 1)
				return 0;
	end
	if (\input("Merge", "Enter name of CSL file to merge",
		Record, %1))
			return 0;
	if (Record::0 = '\n') return 0;
	i := extract(Record, 0, NAMELEN, Auxname);
	fd := t.open(Auxname, T3X.OREAD);
	if (fd < 0) do 
		explain(fd);
		return 0;
	end
	dbmerge(fd, 0);
	t.close(fd);
end

dbinitfile(fd) do var rem, k;
	Nrecords := 0;
	Rawcount := 1;
	rem := RECORDSIZE;
	rem := rem - t.write(fd, "NMH00\n", 6);
	rem := rem - t.write(fd, pntoa(Nfields, 2, '0'), 2);
	rem := rem - t.write(fd, pntoa(Nrecords, 3, '0'), 3);
	rem := rem - t.write(fd, pntoa(Rawcount, 3, '0'), 3);
	rem := rem - t.write(fd, "\n", 1);
	k := str.length(Database);
	rem := rem - t.write(fd, Database, k);
	rem := rem - t.write(fd, "\n", 1);
	k := RECORDSIZE-16-k;
	Record::(k-1) := '\n';
	rem := rem - t.write(fd, Record, k);
	if (rem) iofault("dbinitfile", %1);
end

convert() do
	var	fd, nfd, tname::PATHLEN+1;
	var	k, i, j, q, c;

	if (\input("Import", "Enter name of CSL file to import",
		Record, %1))
			return 0;
	if (Record::0 = '\n') return 0;
	i := extract(Record, 0, NAMELEN, Auxname);
	if (i < 1) return 0;
	fd := t.open(Auxname, T3X.OREAD);
	if (fd < 0) do 
		explain(fd);
		return 0;
	end
	if (\newfile("Title", "Enter a title for the new database",
		"A database with the given name already exists",
		".db", Database)) do
			t.close(fd);
			return 0;
	end
	str.copy(tname, Database);
	strcat(tname, ".db");
	nfd := t.open(tname, T3X.OWRITE);
	if (nfd < 0) do
		t.close(fd);
		explain(nfd);
		return 0;
	end
	k := t.read(fd, Record, RECORDSIZE);
	if (k < 4) do
		t.close(fd);
		return dont("not a valid CSL file");
	end
	i := 0;
	j := 0;
	q := 0;
	Nfields := 0;
	while (1) do
		c := Record::i;
		if (c = '\n' \/ i >= RECORDSIZE) leave;
		ie (q) do
			ie (c = '"') do
				Record::j := '\n';
				j := j+1;
				Nfields := Nfields+1;
				q := 0;
			end
			else do
				Record::j := c;
				j := j+1;
			end
		end
		else do
			if (c = '"') q := 1;
		end
		i := i+1;
	end
	if (i >= RECORDSIZE) do
		t.close(fd);
		return dont("CSL header too long");
	end
	if (Nfields >= FIELDMAX) do
		t.close(fd);
		return dont("CSL file has too many fields");
	end
	for (i=j, RECORDSIZE) Record::i := '-';
	Record::(RECORDSIZE-1) := '\n';
	dbinitfile(nfd);
	t.close(nfd);
	nfd := dbopen(Database);
	if (nfd < 0) do
		t.close(fd);
		explain(nfd);
		return 0;
	end
	reposition(fd, 0, 0, 0);
	dbmerge(fd, 1);
	dbclose();
	t.close(fd);
	return 1;
end

inclheader(upath, fd) do var i, j, k;
	if (O_warnings) do
		info(%1, Xmax<80->2:6, [
		"Including a header record holding the",
		"field names of the current database will",
		"be necessary when eporting data to a",
		"database program other than Node.",
		"When exchanging data with a computer which",
		"is also running Node, chose 'skip'.",
		%1],
		[ (C_infoframe), (C_infotext) ]);
	end
	if (prompt(%1, Xmax<80->10:13-(\O_warnings-> 6: 0), 1,
		"Include header with field names?",
		"Include", "Skip") \= 1)
			return 0;
	j := 0;
	for (i=0, Nfields) do
		Auxrec::j := '"';
		k := str.length(Taglist[i]);
		t.memcopy(@Auxrec::(j+1), Taglist[i], k);
		Auxrec::(j+k+1) := '"';
		Auxrec::(j+k+2) := ',';
		j := j+k+3;
	end
	Auxrec::(j-1) := '\n';
	if (t.write(fd, Auxrec, j) \= j) do
		t.close(fd);
		t.remove(upath);
		dont("Error writing header");
		return -1;
	end
end

metaquote(dst, src, len) do var i, j;
	j := 0;
	for (i=0, len) do
		dst::j := src::i;
		j := j+1;
		if (src::i = '"' \/ src::i = '\\') do
			dst::(j-1) := '\\';
			dst::j := src::i;
			j := j+1;
		end
	end
	return j;
end

export() do
	var	i, j, k, l, n, fd;
	var	path::PATHLEN+1;
	var	fields[FIELDMAX];

	if (\tagged()) do
		dont("No records have been tagged for export");
		return 0;
	end
	if (\newfile("File", "Enter the name of the export file",
		"A file with the given name already exists", "",
		path))
			return 0;
	fd := t.open(path, T3X.OWRITE);
	if (fd < 0) do
		dont("File creation failed");
		return 0;
	end
	n := 0;
	if (inclheader(path, fd) < 0) return 0;
	tty.color(C_background); tty.clear();
	tty.color(C_browsetext); fbox(10, 2, Xmax-10, Ymax-3);
	info(%1, 5, [ "Exporting: ___ of ___", %1],
		[ (C_infoframe), (C_infotext) ]);
	tty.move(Xmax<80->39:47, 6); tty.writes(pntoa(tagged(), 3, '_'));
	for (i=1, Nrecords+1) do
		if (Tagtbl::i) do
			n := n+1;
			tty.move(Xmax<80->32:40,6);
			tty.writes(pntoa(n, 3, '_'));
			dbread(i, Record);
			dbsplit(Record, fields);
			k := 0;
			for (j=0, Nfields) do
				Auxrec::k := '"';
				l := str.length(fields[j]);
				ie (str.scan(fields[j], '"'))
					l := metaquote(@Auxrec::(k+1),
						fields[j], l);
				else
					t.memcopy(@Auxrec::(k+1),
						fields[j], l);
				Auxrec::(k+l+1) := '"';
				k := k+l+2;
				if (j < Nfields-1) do
					Auxrec::k := ','; k := k+1;
				end
			end
			Auxrec::k := '\n';
			if (t.write(fd, Auxrec, k+1) \= k+1) do
				t.close(fd);
				t.remove(path);
				dont("File write error");
				return 0;
			end
		end
	end
	info(%1, 5, [ "___ records exported.", %1],
		[ (C_infoframe), (C_infotext) ]);
	tty.move(Xmax<80->21:29, 6); tty.writes(pntoa(n, 3, '_'));
	hintbar(Ymax-2, "Export done - press [ENTER]");
	getkey();
	t.close(fd);
end

information() do var m;
	m := [	"___  Fields (columns)",
		"___  Records (rows)",
		"___  Disk blocks",
		"",
		"File descriptor = ___",
		%1 ];
	t.memcopy(m[0], pntoa(Nfields, 3, '_'), 3);
	t.memcopy(m[1], pntoa(Nrecords, 3, '_'), 3);
	t.memcopy(m[2], pntoa(Rawcount, 3, '_'), 3);
	t.memcopy(@m[4]::18, pntoa(Dbfd, 3, '_'), 3);
	info(%1, %1, m, [ (C_infoframe), (C_infotext) ]);
	hintbar(Ymax-2, "Press [ENTER]");
	getkey();
end

databasemenu() do var i;
	i := menu(%1, %1, 0, [
		"Change view        [V]",
		"Pack database      [P]",
		"Edit structure     [E]",
		"Merge databases    [M]",
		"Export records     [X]",
		"Information        [I]",
		%1 ],
		[ 'v', 'p', 'e', 'm', 'x', 'i' ], [
		"Select fields to display or hide",
		"Condense the database by removing unused records",
		"Add or remove database fields",
		"Import a CSL-format database and merge records",
		"Write selected records to a CSL-format file",
		"Display some (internal) information about the database"
		], C_browsetext);
	ie (i = 0) changeview();
	else ie (i = 1) packdb();
	else ie (i = 2) editstruct();
	else ie (i = 3) import();
	else ie (i = 4) export();
	else if (i = 5) information();
end

var	Lx, Ly;

m(s) do
	tty.move(Lx, Ly);
	if (\s \/ Ly >= Ymax-3) do
		tty.color(C_titlehi);
		tty.move(Lx, Ly+1);
		tty.writes(s->
			"[More text follows, press ENTER]":
			"[Press ENTER to return]");
		getkey();
		Ly := 1;
		tty.clear();
		tty.color(C_background);
		if (\s) return;
		tty.move(Lx, Ly);
	end
	tty.writes(s);
	Ly := Ly+1;
end

license() do
	tty.color(C_background);
	tty.clear();
	Lx := Xmax/2-32;
	Ly := 1;
	m("Node -- Nils' Own DatabasE");
	m("Copyright (C) 1997-2003 Nils M Holm.  All rights reserved.");
	m("");
	m("Redistribution and use in source and binary forms, with or");
	m("without modification, are permitted provided that the following");
	m("conditions are met:");
	m("");
	m("1. Redistributions of source code must retain the above");
	m("   copyright notice, this list of conditions and the following");
	m("   disclaimer.");
	m("2. Redistributions in binary form must reproduce the above");
	m("   copyright notice, this list of conditions and the following");
	m("   disclaimer in the documentation and/or other materials");
	m("   provided with the distribution.");
	m("");
	m("THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS");
	m("``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT");
	m("NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND");
	m("FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT");
	m("SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,");
	m("INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL");
	m("DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF");
	m("SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR");
	m("BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF");
	m("LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT");
	m("(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF");
	m("THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY");
	m("OF SUCH DAMAGE.");
	m(0);
end

setup() do var i, err;
	ie (O_zoom) do
		Xmax := NCXCOLS;
		Ymax := NCXLINES;
	end
	else do
		Xmax := tty.columns();
		Ymax := tty.lines();
	end
	err := 0;
	ie (Xmax < 64 \/ Ymax < 18) do
		t.write(T3X.SYSERR, "Node: screen too small\r\n", 24);
		err := 1;
	end
	else if (Xmax >= MAXCOLS) do
		t.write(T3X.SYSERR, "Node: screen too big\r\n", 22);
		err := 1;
	end
	if (err) do
		tty.mode(0);
		tty.reset();
		tty.fini();
		sys.fini();
		halt 1;
	end
	for (i=0,Xmax) Blanks::i := '\s';
	for (i=0,Xmax) Hline::i := O_borderc::4;
	Blanks::i := 0;
	Blanks::(i+1) := 0;
	tty.color(C_background);
	tty.clear();
end

loadcset() do var p, buf::PATHLEN+1, r, e, sfx;
	hintbar(Ymax-2, "Select color set to load");
	p := fbx.select(Xmax/2-20, Ymax/2-7, 40, 12,
		[ (C_menutext), (C_menuframe), (C_edittext),
		  (C_menuhigh), (C_menubar) ],
		O_borderc,
		"[Select Color Set]", ".", O_dosflag->"CS":
			"cs", buf);
	if (\p) return;
	r := Cnf.load(p, @e);
	if (r < -1) do
		dont("failed to open color set file");
		return;
	end
	if (r < 0) do
		dont("invalid color set file");
		return;
	end
	setup();
end

changeopts() do var i;
	i := menu(%1, %1, 0, [
		(O_hints->
			"Hint bars ...... ON ":
			"Hint bars ...... OFF"),
		(O_warnings->
			"Warning msgs ... ON ":
			"Warning msgs ... OFF"),
		(O_zoom->
			"Zoom mode ...... ON ":
			"Zoom mode ...... OFF"),
		"Load color set ...  ",
		%1 ],
		[ 'h', 'w', 'z', 'l' ], [
		"Show hint bars (like this)",
		"Enable warning messages",
		"Enable HP1000CX 64x18 layout",
		"Select predefined color set",
		], C_BROWSETEXT);
	ie (i = 0) do
		O_hints := \O_hints;
	end
	else ie (i = 1) do
		O_warnings := \O_warnings;
	end
	else ie (i = 2) do
		O_zoom := \O_zoom;
	end
	else if (i = 3) do
		loadcset();
	end
	setup();
end

browsermenu(rn) do var i;
	i := menu(%1, %1, 0, [
		"Insert records    [INS]",
		"Delete records    [DEL]",
		"Selections ...      [S]",
		"Report writer ...   [R]",
		"Database ...        [D]",
		"Set options ...     [E]",
		"Help                [?]",
		"Display license        ",
		"Close database      [C]",
		%1 ],
		[ ttyctl.K_INS, ttyctl.K_DEL, 's', 'r', 'd', 'e', '?',
			255, 'c' ], [
		"Add new records to the database",
		"Remove current record or tagged records",
		"Tag or untag records",
		"Write records to a file or print records",
		"Maintenance: edit structure, pack, export, merge",
		"Customize options",
		"Get further help",
		"Display the conditions of use",
		"Return to the opening menu"
		], C_browsetext);
	ie (i = 0) rn := newrecord(rn);
	else ie (i = 1) delrecords(rn);
	else ie (i = 2) rn := selections(rn);
	else ie (i = 3) reportwriter();
	else ie (i = 4) databasemenu();
	else ie (i = 5) changeopts();
	else ie (i = 6) browserhelp();
	else ie (i = 7) license();
	else if (i = 8) DoExit := 1;
	return rn;
end

emptymenu(rn) do var i;
	i := menu(%1, %1, 0, [
		"Insert records    [INS]",
		"Set options ...     [E]",
		"Display license        ",
		"Close database      [C]",
		%1 ],
		[ ttyctl.K_INS, 'e', 255, 'c' ], [
		"Add new records to the database",
		"Customize options",
		"Display the conditions of use",
		"Return to the opening menu",
		], C_browsetext);
	ie (i = 0) rn := newrecord(rn);
	else ie (i = 1) changeopts();
	else ie (i = 2) license();
	else DoExit := 1;
	return rn;
end

showrecord(x, y, tg, buffer) do
	var	i, j, k, c;
	var	fc, fl, fp;

	fl := (Xmax-4) / Vfields;
	k := 0;
	fc := 0;
	fp := 0;
	tty.move(x-1, y); tty.writes(tg->">":"\s");
	for (j=0, RECORDSIZE) do
		if (Record::j = '\n') do
			! tty.move(fp*fl+x, y);
			ie (\Vlist[fc]) do
				;
			end
			else ie (j-k >= fl-2) do
				c := Record::(k+fl-2);
				Record::(k+fl-2) := 0;
				tty.writes(@Record::k);
				Record::(k+fl-2) := c;
				fp := fp+1;
			end
			else do
				c := Record::j;
				Record::j := 0;
				tty.writes(@Record::k);
				Record::j := c;
				tty.writes(@Blanks::(Xmax - fl + 2 + j - k));
				fp := fp+1;
			end
			k := j+1;
			fc := fc+1;
			if (fc >= Nfields \/ fp >= Vfields) leave;
			if (Vlist[fc]) tty.writes("\s\s");
		end
	end
	tty.writes(tg->"<":"\s");
end

showframe(x) do
	var	i, j, pos;
	var	fl;
	var	fname::81;

	fl := (Xmax-4) / Vfields;
	tty.color(C_browseframe);
	box(0, 2, Xmax, Ymax-3);
	tty.color(C_browsehead);
	pos := 0;
	for (i=0, Nfields) do
		if (Vlist[i]) do
			tty.move(pos*fl+x, 3);
			str.copy(fname, Taglist[i]);
			j := str.length(fname);
			if (j >= fl-1) fname::(fl-2) := 0;
			tty.writes(fname);
			pos := pos+1;
		end
	end
	tty.color(C_browsetext);
end

dbbrowse() do
	var	i, j, k;
	var	fl, vl;
	var	rn, top, redraw, adjust;
	var	x;

	rn := 1;
	top := 1;
	adjust := 2;
	DoExit := 0;
	while (1) do
		if (SavedLimited) limitview();
		if (adjust) do
			if (adjust = 2) do
				fl := (Xmax-4) / Vfields;
				x := (Xmax/2) - fl*Vfields/2;
				vl := Ymax-9;
				showframe(x);
			end
			if (rn > Nrecords) rn := Nrecords;
			if (rn < top \/ rn-top >= vl) do
				top := rn-vl/2;
				if (top < 1) top := 1;
			end
			redraw := 2;
			adjust := 0;
		end
		if (redraw) do
			if (redraw > 1) showframe(x);
			dbinfo(rn, 1);
			for (i=0, vl) do
				if (i+top > Nrecords) leave;
				tty.color(Tagtbl::(top+i)-> C_browsetag:
					C_browsetext);
				dbread(top+i, Record);
				showrecord(x, i+5, Tagtbl::(top+i), Record);
			end
			for (i=i, vl) do
				tty.move(0, i+5);
				tty.writes(Blanks);
			end
			redraw := 0;
		end
		if (\Nrecords) do
			rn := emptymenu(rn);
			if (DoExit) leave;
			adjust := 1;
			loop;
		end
		dbinfo(rn, 0);
		dbread(rn, Record);
		tty.color(Tagtbl::rn-> C_tagind: C_browsebar);
		showrecord(x, rn-top+5, Tagtbl::rn, Record);
		k := getkey();
		ie (\Ntagged /\ (k = ttyctl.K_ESC \/ k = ':' \/
			k = ttyctl.K_DEL \/ k = 127)
		)
			tty.color(C_marker);
		else
			tty.color(Tagtbl::rn-> C_browsetag: C_browsetext);
		showrecord(x, rn-top+5, Tagtbl::rn, Record);
		ie (k = ttyctl.K_ESC \/ k = ':' \/ k = ttyctl.K_LEFT) do
			SavedLimited := unlimitview();
			rn := browsermenu(rn);
			if (DoExit) leave;
			adjust := 2;
			loop;
		end
		else ie ((k = ttyctl.K_DOWN \/ k = 'N'-'@') /\
			rn < Nrecords
		) do
			rn := rn+1;
			if (rn-top >= vl) do
				top := top+1;
				redraw := 1;
			end
		end
		else ie ((k = ttyctl.K_UP \/ k = 'P'-'@') /\ rn > 1) do
			rn := rn-1;
			if (rn < top) do
				top := top-1;
				redraw := 1;
			end
		end
		else ie (k = ttyctl.K_PGDN \/ k = 'F'-'@') do
			top := top+vl-1;
			rn := top;
			if (top >= Nrecords) do
				top := Nrecords-vl+1;
				if (top < 1) top := 1;
				rn := Nrecords;
			end
			redraw := 1;
		end
		else ie (k = ttyctl.K_PGUP \/ k = 'B'-'@') do
			top := top-vl+1;
			if (top < 1) top := 1;
			rn := top;
			redraw := 1;
		end
		else ie (k = ttyctl.K_END \/ k = 'E'-'@') do
			top := Nrecords-vl+1;
			if (top < 1) top := 1;
			rn := Nrecords;
			redraw := 1;
		end
		else ie (k = ttyctl.K_HOME \/ k = 'A'-'@') do
			redraw := top-> 1: 0;
			top := 1;
			rn := 1;
		end
		else ie (k = '\s') do
			if (Limited) loop;
			Tagtbl::rn := \Tagtbl::rn;
			Ntagged := Ntagged + (Tagtbl::rn-> 1: %1);
			tty.color(Tagtbl::rn-> C_browsetag:
				C_browsetext);
			showrecord(x, rn-top+5, Tagtbl::rn, Record);
			if (rn < Nrecords) do
				rn := rn+1;
				if (rn-top >= vl) do
					top := top+1;
					redraw := 1;
				end
			end
			if (\redraw) dbinfo(rn, 1);
		end
		else ie (k = ttyctl.K_CR \/ k = ttyctl.K_RIGHT) do
			tty.color(C_background); tty.clear();
			rn := dbedit(rn, Limited);
			adjust := 1;
		end
		else ie (k = ttyctl.K_INS) do
			SavedLimited := unlimitview();
			rn := newrecord(rn);
			adjust := 1;
		end
		else ie (k = ttyctl.K_DEL \/ k = 127) do
			unlimitview();
			delrecords(rn);
			adjust := 1;
		end
		else ie (k = 's' \/ k = 'S') do
			unlimitview();
			selectrecords(0, 0);
			redraw := 2;
		end
		else ie (k = 'e' \/ k = 'E') do
			changeopts();
			adjust := 2;
		end
		else ie (k = '/') do
			rn := quicklocate(rn);
			adjust := 1;
		end
		else ie (k = 'l' \/ k = 'L') do
			rn := limitedview();
			adjust := 1;
		end
		else if (k = '?' \/ k = ttyctl.K_F1) do
			browserhelp();
			redraw := 2;
		end
	end
end

dbcreate() do
	var	k, i, rem;
	var	fd;
	var	path::PATHLEN+1;

	if (\newfile("Title", "Enter a title for the new database",
		"A database with the given name already exists",
		".db", Database))
			return 0;
	tty.color(C_background); tty.clear();
	hintbar(Ymax-2, "Enter field names, [ESC] = done");
	killbuffer(Record, FIELDMAX);
	edit(-1, %1, %1, 40, [ "#01", "#02", "#03",
			"#04", "#05", "#06",
			"#07", "#08", "#09",
			"#10", "#11", "#12",
			"#13", "#14", "#15",
			"#16", %1],
			Record, [ ttyctl.K_ESC, %1 ], 0, 0);
	Nfields := normalize(Record);
	if (Record::0 = '\n') return 0;
	str.copy(path, Database);
	strcat(path, ".db");
	fd := t.open(path, T3X.OWRITE);
	if (fd < 0) return ECREAT;
	dbinitfile(fd);
	t.close(fd);
	return 1;
end

dbuse(s) do var i, path::PATHLEN+1, p;
	ie (s \= %1) do
		str.copy(Auxname, s);
	end
	else do
		if (\input("Title",
			"Enter title of database to open, [ENTER]=list",
				Record, %1))
					return 0;
		ie (Record::0 = '\n') do
			hintbar(Ymax-2, "Select database to open");
			sys.getdir(path, PATHLEN+1);
			p := fbx.select(Xmax/2-20, Ymax/2-7, 40, 12,
				[ (C_menutext), (C_menuframe), (C_edittext),
				  (C_menuhigh), (C_menubar) ],
				O_borderc,
				"[Open Database]", path,
				O_dosflag-> "DB": "db",
				Auxname);
			if (\p) return;
			p := str.rscan(Auxname, '.');
			if (p >= 0) Auxname::p := 0;
		end
		else do
			i := extract(Record, 0, NAMELEN, Auxname);
			Auxname::i := 0;
		end
	end
	str.copy(Database, Auxname);
	i := dbopen(Database);
	if (i < 0) do 
		explain(i);
		return 0;
	end
	dbbrowse();
	dbclose();
end

logo(x, y, s) do var i;
	tty.move(x, y);
	i := 0;
	while (s::i) do
		tty.color(s::i = 'X'-> C_logo:
			s::i = ':'-> ttyctl.F_BLACK:
			C_background);
		tty.writec('\s');
		i := i+1;
	end
end

header() do var i, x;
	x := Xmax/2-23;
	i := Ymax/2-6;
	if (O_dosflag /\ Ymax < 24) i := i-2;
	tty.color(C_background); tty.clear();
	logo(x, i+0, "                               XX  ");
	logo(x, i+1, "                               XX::");
	logo(x, i+2, " XXXXXXXX    XXXXXXXX    XXXXXXXX:: XXXXXXX ");
	logo(x, i+3, "XXXX:::XXX: XXXX:::XXX: XXXX:::XX::XXX::::XX:");
	logo(x, i+4, "XXX:::  XX::XXX:::  XX::XXX::  XX::XXXXXXXXX::");
	logo(x, i+5, "XXX::   XX::XXXX:  XXX::XXXX:  XX::XXX::::::::");
	logo(x, i+6, "XXX::   XX:: XXXXXXXX::: XXXXXXXX:: XXXXXXX");
	logo(x, i+7, " ::::   ::::  :::::::::   :::::::::  ::::::::");
	tty.color(C_titlehi);
	tty.move(x+17, i+9);
	tty.writes("Version 3.4");
	tty.move(x+5, i+11);
	tty.writes("Copyright (C) 1997-2003 Nils M Holm");
	if (O_dosflag) do
		tty.move(x+18, i+13);
		tty.writes("[DOS mode]");
	end
	tty.color(C_titlelo);
	tty.move(Xmax/2-7, Ymax-2);
	tty.writes("Press [ENTER]");
	getkey();
end

mainmenu() do var k, i;
	while (1) do
		tty.color(C_background); tty.clear();
		k := menu(%1, %1, 0, [
			"Open database        [O]",
			"Create new database  [N]",
			"Import CSL file      [I]",
			"Set options ...      [E]",
			"Display License         ",
			"Quit                 [Q]",
			%1 ],
			[ 'o', 'n', 'i', 'e', 255, 'q' ], [
			"Open an existing database",
			"Create a new database from the scratch",
			"Convert a CSL file into a Node database",
			"Customize options",
			"Display the conditions of use",
			"Leave Node"
			], C_background);
		ie (k = 0) dbuse(%1);
		else ie (k = 1) do
			i := dbcreate();
			ie (i < 0) explain(i);
			else if (i) dbuse(Database);
		end
		else ie (k = 2) do
			if (convert()) do
				dbuse(Database);
			end
		end
		else ie (k = 3) changeopts();
		else ie (k = 4) license();
		else if (k = %1 \/ k = 5) leave;
	end
end

init() do var buf::80;
	const   TXT = config.T_STRING,
		NUM = config.T_NUMERIC,
		COL = config.T_COLOR;
	const	C00 = ttyctl.F_GREY|ttyctl.F_BRIGHT|ttyctl.B_BLUE,
		C01 = ttyctl.F_YELLOW|ttyctl.F_BRIGHT|ttyctl.B_RED,
		C02 = ttyctl.B_CYAN,
		C03 = ttyctl.F_GREY|ttyctl.F_BRIGHT|ttyctl.B_CYAN,
		C04 = ttyctl.F_GREY|ttyctl.F_BRIGHT|ttyctl.B_YELLOW,
		C05 = ttyctl.F_CYAN|ttyctl.F_BRIGHT|ttyctl.B_CYAN,
		C06 = ttyctl.B_YELLOW,
		C07 = ttyctl.F_GREY|ttyctl.F_BRIGHT|ttyctl.B_YELLOW,
		C08 = ttyctl.B_CYAN,
		C09 = ttyctl.F_GREY|ttyctl.F_BRIGHT|ttyctl.B_CYAN,
		C10 = ttyctl.F_GREY|ttyctl.F_BRIGHT|ttyctl.B_YELLOW,
		C11 = ttyctl.B_GREY,
		C12 = ttyctl.F_RED|ttyctl.B_GREY,
		C13 = ttyctl.F_BLACK|ttyctl.B_GREY,
		C14 = ttyctl.F_GREY|ttyctl.F_BRIGHT|ttyctl.B_YELLOW,
		C15 = ttyctl.B_GREY,
		C16 = ttyctl.F_BLACK|ttyctl.B_GREY,
		C17 = ttyctl.F_RED|ttyctl.B_GREY,
		C18 = ttyctl.F_GREY|ttyctl.F_BRIGHT|ttyctl.B_YELLOW,
		C19 = ttyctl.F_CYAN|ttyctl.B_GREY,
		C20 = ttyctl.B_CYAN,
		C21 = ttyctl.F_CYAN|ttyctl.F_BRIGHT|ttyctl.B_BLUE,
		C22 = ttyctl.F_CYAN|ttyctl.B_BLUE,
		C23 = ttyctl.B_CYAN,
		C24 = ttyctl.F_BLUE|ttyctl.B_CYAN,
		C25 = ttyctl.F_BRIGHT|ttyctl.F_BLUE|ttyctl.B_CYAN,
		C26 = ttyctl.F_BRIGHT|ttyctl.F_CYAN|ttyctl.B_YELLOW,
		C27 = ttyctl.F_BRIGHT|ttyctl.F_GREY|ttyctl.B_GREY,
		C28 = ttyctl.F_BRIGHT|ttyctl.F_CYAN|ttyctl.B_GREY;

	Cnf.init([
	[ "color-background",	COL, C00,		@C_background	],
	[ "color-alert",	COL, C01,		@C_alert	],
	[ "color-menuframe",	COL, C02,		@C_menuframe	],
	[ "color-menutext",	COL, C03,		@C_menutext	],
	[ "color-menubar",	COL, C04,		@C_menubar	],
	[ "color-menuhigh",	COL, C05,		@C_menuhigh	],
	[ "color-infoframe",	COL, C06,		@C_infoframe	],
	[ "color-infotext",	COL, C07,		@C_infotext	],
	[ "color-promptframe",	COL, C08,		@C_promptframe	],
	[ "color-prompttext",	COL, C09,		@C_prompttext	],
	[ "color-promptbar",	COL, C10,		@C_promptbar	],
	[ "color-editframe",	COL, C11,		@C_editframe	],
	[ "color-editprompt",	COL, C12,		@C_editprompt	],
	[ "color-edittext",	COL, C13,		@C_edittext	],
	[ "color-editbar",	COL, C14,		@C_editbar	],
	[ "color-browseframe",	COL, C15,		@C_browseframe	],
	[ "color-browsetext",	COL, C16,		@C_browsetext	],
	[ "color-browsehead",	COL, C17,		@C_browsehead	],
	[ "color-browsebar",	COL, C18,		@C_browsebar	],
	[ "color-browsetag",	COL, C19,		@C_browsetag	],
	[ "color-logo",		COL, C20,		@C_logo		],
	[ "color-titlehi",	COL, C21,		@C_titlehi	],
	[ "color-titlelo",	COL, C22,		@C_titlelo	],
	[ "color-helpframe",	COL, C23,		@C_helpframe	],
	[ "color-helptext",	COL, C24,		@C_helptext	],
	[ "color-helpkey",	COL, C25,		@C_helpkey	],
	[ "color-tagind",	COL, C26,		@C_tagind	],
	[ "color-marker",	COL, C27,		@C_marker	],
	[ "color-limitind",	COL, C28,		@C_limitind	],
	[ "border-chars",	TXT, "\s\s\s\s\s\s",	@O_borderc	],
	[ "show-hints",		NUM, 1,			@O_hints	],
	[ "show-warnings",	NUM, 1,			@O_warnings	],
	[ "zoom-mode",		NUM, 0,			@O_zoom		],
	[ "report-generator",	TXT, "./node_rg",	@O_rgpath	],
	[ "rg-print-command",	TXT, "/usr/bin/lp",	@O_rg_print	],
	[ "rg-view-command",	TXT, "/usr/bin/more",	@O_rg_view	],
	[ "rg-add-cr",		NUM, 1,			@O_rg_addcr	],
	[ "rg-default-flags",	NUM, 24,		@O_rg_flags	],
	0 ]);
	Nxbits := t.bpw() = 4-> 2: 1;
	! If COMSPEC is defined, we're probably running under DOS
	O_dosflag := t.getenv("COMSPEC", buf, 80) > 0;
	Dbfd := %1;
	Record::RECORDSIZE := 0;
	Auxrec::RECORDSIZE := 0;
	Limited := 0;
	Lasthint := 0;
	Lastcopy := 0;
	Confpath::0 := 0;
	setup();
end

configure() do
	var	home::PATHLEN, p2::PATHLEN;
	var	cpaths, i, r, ln;
	var	lno::10;

	cpaths := [ "node.rc", 0, 0 ];
	if (t.getenv("HOME", home, PATHLEN-10) > 0) do
		str.copy(p2, home);
		strcat(home, "/");
		strcat(home, ".noderc");
		strcat(p2, "/");
		strcat(p2, "node.rc");
		cpaths[1] := home;
		cpaths[2] := p2;
	end
	for (i=0, 3) do
		r := Cnf.load(cpaths[i], @ln);
		if (r \= -2) leave;
	end
	if (r \= -2 /\ i < 3) str.copy(Confpath, cpaths[i]);
	if (r = -1) do
		str.numtostr(lno, ln, 10);
		info(1, 1,
			[ "Error in config file, line",
			 (lno),
			 "Press [ENTER]",
			 %1 ],
			[ (C_infoframe), (C_infotext) ]);
		tty.readc();
		tty.color(ttyctl.F_GREY|ttyctl.B_BLACK);
		tty.move(0, Ymax-1); tty.clreol();
		tty.reset();
		tty.fini();
		sys.fini();
		halt 1;
	end
	setup();
end

do
	sys.init();
	tty.init();
	tty.mode(1);
	init();
	configure();
	setup();
	header();
	mainmenu();
	updateconf();
	tty.color(ttyctl.F_GREY|ttyctl.B_BLACK);
	tty.clear();
	tty.mode(0);
	tty.reset();
	tty.fini();
	sys.fini();
end

